#include "Fps.h"

void initFPS(FPSManager*fps) {
     fps->now = 0;
	 fps->framerate = 0;
	 fps->last = SDL_GetTicks();
	 fps->limitbegin = SDL_GetTicks();
	 fps->limitdelay = 0;
}

float getFPS(FPSManager*fps) {
     fps->framerate++;
	 fps->now = SDL_GetTicks();
	 if(fps->now!=fps->last) {
	     return (float)(fps->framerate/((fps->now-fps->last)/1000.0f));
		 fps->framerate = 0;
		 fps->last = fps->now;//1 seconde s'est donc coul
	 }
	 return 0;
}

int delayUpdateFPS(FPSManager*fps) {
     fps->limitbegin = SDL_GetTicks();
     return 0;
}

int delayFPS(FPSManager*fps, float delay) {
     fps->limitdelay = SDL_GetTicks()-fps->limitbegin;//SDL_GetTicks() en millisecondes: fps->limitdelay est le temps coul pendant le passage d'une fois la boucle principale :p
	 if(fps->limitdelay < ((1000.0f/delay)-(delay/100.0f))) {//-0.60f pour delay == 60.0f (1000.0/60.0f == 0.60f) car on peut imaginer que l'image s'affiche au bout de 600 microsecondes donc on enlve ce temps au delay
	     SDL_Delay(((1000.0f/delay)-(delay/100.0f))-fps->limitdelay);//on fais une pause pour allger le processeur en faisant une limite par rapport  delay si delay = 60.0f (pour une bonne fluidit) alors une image s'affichera toutes les 16 millisecondes car 1000.0(1 seconde = 1000 ms)/60.0f = 16.0f -0.60f car l'image ne s'affiche relement qu'au bout de 600 microsecondes et les 15.4 millisecondes ne sont pas utilise donc on bloque le programme dans ce 15.4 millisecondes :p
	 }
	 return 0;
}	 
