#include "FreeFlyCamera.h"

void updateFreeFlyCamera(FreeFlyCamera*freefly) {
     
	 if(freefly->phi > 89) {//limite que pour l'angle phi qui rgie le dplacement  l'horizontale sur l'axe z
	     freefly->phi = 89;
	 }
	 else if(freefly->phi < -89) {
	     freefly->phi = -89;
	 }
	 
	 freefly->camera.ciblex = 1*cos((freefly->phi*3.14159265f)/180.0f)*cos((freefly->theta*3.14159265f)/180.0f);//on met  jour la cible regard sivant l'angle modifi theta et phi :) on passe donc des coordonnes sphriques aux coordonnes cartsiennes en passant des angles  des nombres;
	 freefly->camera.cibley = 1*cos((freefly->phi*3.14159265f)/180.0f)*sin((freefly->theta*3.14159265f)/180.0f);
	 freefly->camera.ciblez = 1*sin((freefly->phi*3.14159265f)/180.0f);//avec r=1 qui est une normale
	 
	 freefly->camera.verticalx = 0.0f;
	 freefly->camera.verticaly = 0.0f;
	 freefly->camera.verticalz = 1.0f;
	 //pour un mouvement latral on calcule d'abord avec un produit vectoriel la normale du dplacement (cad la perpendiculaire  la face):
	 freefly->camera.lateralx = (freefly->camera.cibley*freefly->camera.verticalz)-(freefly->camera.ciblez*freefly->camera.verticaly);
	 freefly->camera.lateraly = (freefly->camera.ciblez*freefly->camera.verticalx)-(freefly->camera.ciblex*freefly->camera.verticalz);
	 freefly->camera.lateralz = (freefly->camera.ciblex*freefly->camera.verticaly)-(freefly->camera.cibley*freefly->camera.verticalx);
	 //on normalise le vecteur lateral pour l'avoir en une taille de 1 :
	 freefly->camera.lateralnormalize = sqrt((freefly->camera.lateralx*freefly->camera.lateralx)+(freefly->camera.lateraly*freefly->camera.lateraly)+(freefly->camera.lateralz*freefly->camera.lateralz));
	 freefly->camera.lateralx /= freefly->camera.lateralnormalize;
	 freefly->camera.lateraly /= freefly->camera.lateralnormalize;
	 freefly->camera.lateralz /= freefly->camera.lateralnormalize;
	 
	 freefly->camera.lookx = freefly->camera.posx+freefly->camera.ciblex;//pour dterminer o regarde la camra il suffit d'aditionner la position de la camra et la cible vu en x y et z;)
	 freefly->camera.looky = freefly->camera.posy+freefly->camera.cibley;
	 freefly->camera.lookz = freefly->camera.posz+freefly->camera.ciblez;
}

void initFreeFlyCamera(FreeFlyCamera*freefly, float positionx, float positiony, float positionz, float speed, float precision, int state) {
     freefly->phi = 0.0f;
	 freefly->theta = 0.0f;
	 freefly->speed = speed;
	 freefly->precision = precision;
	 freefly->statutdeplacement = state;
	 freefly->upstate = 0;
	 freefly->downstate = 0;
	 freefly->camera.posx = positionx;
	 freefly->camera.posy = positiony;
	 freefly->camera.posz = positionz;
	 freefly->camera.lateralx = 0.0f;
	 freefly->camera.lateraly = 0.0f;
	 freefly->camera.lateralz = 0.0f;
	 freefly->camera.lookx = 0.0f;
	 freefly->camera.looky = 0.0f;
	 freefly->camera.lookz = 0.0f;
	 freefly->camera.ciblex = 0.0f;
	 freefly->camera.cibley = 0.0f;
	 freefly->camera.ciblez = 0.0f;
	 freefly->camera.oldposx = 0.0f;
	 freefly->camera.oldposy = 0.0f;
	 freefly->camera.oldposz = 0.0f;
	 updateFreeFlyCamera(&(*freefly));//pour positionner la camra :)
}

#ifdef WINDOWS
void setHideCursorMouseFreeFlyCamera(int hidecursor) {
     if(hidecursor == 1) {
	     SDL_WM_GrabInput(SDL_GRAB_ON);
		 SDL_ShowCursor(SDL_DISABLE);
	 }
	 else {
	     SDL_WM_GrabInput(SDL_GRAB_OFF);
		 SDL_ShowCursor(SDL_ENABLE);
	 }
}

void mouseMotionGestionFreeFlyCamera(FreeFlyCamera*freefly, SDL_MouseMotionEvent*event) {
	 freefly->theta -= event->xrel*freefly->precision;//on prend les coordonnes relative de la souris pour savoir o est la souris
	 freefly->phi -= event->yrel*freefly->precision;
	 updateFreeFlyCamera(&(*freefly));//on met  jour la cible de la camra :p
}

void keyboardGestionFreeFlyCamera(FreeFlyCamera*freefly, SDL_KeyboardEvent*event) {
	 if(event->type == SDL_KEYDOWN) {
	     if(event->keysym.sym == SDLK_UP) {
		     freefly->upstate = 1;
		 }
		 if(event->keysym.sym == SDLK_DOWN) {
		     freefly->downstate = 1;
		 }
		 if(event->keysym.sym == SDLK_RIGHT) {
		     freefly->rightstate = 1;
		 }
		 if(event->keysym.sym == SDLK_LEFT) {
		     freefly->leftstate = 1;
		 }
	 }
	 else if(event->type == SDL_KEYUP) {
	     if(event->keysym.sym == SDLK_UP) {
		     freefly->upstate = 0;
		 }
		 if(event->keysym.sym == SDLK_DOWN) {
		     freefly->downstate = 0;
		 }
		 if(event->keysym.sym == SDLK_RIGHT) {
		     freefly->rightstate = 0;
		 }
		 if(event->keysym.sym == SDLK_LEFT) {
		     freefly->leftstate = 0;
		 }		 
	 }	 
}

void straightGestionFreeFlyCamera(FreeFlyCamera*freefly) {
	 if(freefly->upstate) {
		 if(freefly->statutdeplacement == LIBERTY) {
	             freefly->camera.posx+=freefly->camera.ciblex*freefly->speed;
		         freefly->camera.posy+=freefly->camera.cibley*freefly->speed;
		         freefly->camera.posz+=freefly->camera.ciblez*freefly->speed;
	     }
		 else if(freefly->statutdeplacement == RESTRICT) {
	             freefly->camera.posx+=freefly->camera.ciblex*freefly->speed;
		         freefly->camera.posy+=freefly->camera.cibley*freefly->speed;
		         freefly->camera.posz = freefly->camera.posz;
		 }
	 }
	 if(freefly->downstate) {
		 if(freefly->statutdeplacement == LIBERTY) {
	             freefly->camera.posx-=freefly->camera.ciblex*freefly->speed;
		         freefly->camera.posy-=freefly->camera.cibley*freefly->speed;
		         freefly->camera.posz-=freefly->camera.ciblez*freefly->speed;
	     }
		 else if(freefly->statutdeplacement == RESTRICT) {
	             freefly->camera.posx-=freefly->camera.ciblex*freefly->speed;
		         freefly->camera.posy-=freefly->camera.cibley*freefly->speed;
		         freefly->camera.posz = freefly->camera.posz;
		 }	 
	 }
	 if(freefly->rightstate) {
		 if(freefly->statutdeplacement == LIBERTY) {
	             freefly->camera.posx+=freefly->camera.lateralx*freefly->speed;
		         freefly->camera.posy+=freefly->camera.lateraly*freefly->speed;
		         freefly->camera.posz+=freefly->camera.lateralz*freefly->speed;
	     }
		 else if(freefly->statutdeplacement == RESTRICT) {
	             freefly->camera.posx+=freefly->camera.lateralx*freefly->speed;
		         freefly->camera.posy+=freefly->camera.lateraly*freefly->speed;
		         freefly->camera.posz = freefly->camera.posz;
		 }
     }		 
	 if(freefly->leftstate) {
		 if(freefly->statutdeplacement == LIBERTY) {
	             freefly->camera.posx-=freefly->camera.lateralx*freefly->speed;
		         freefly->camera.posy-=freefly->camera.lateraly*freefly->speed;
		         freefly->camera.posz-=freefly->camera.lateralz*freefly->speed;
	     }
		 else if(freefly->statutdeplacement == RESTRICT) {
	             freefly->camera.posx-=freefly->camera.lateralx*freefly->speed;
		         freefly->camera.posy-=freefly->camera.lateraly*freefly->speed;
		         freefly->camera.posz = freefly->camera.posz;
		 }
     }	     
	 updateFreeFlyCamera(&(*freefly));//on met  jour la cible vu par la camra avec les nouveaux angles
}	 
#endif

#ifdef PSP
void mouseMotionGestionFreeFlyCamera(FreeFlyCamera*freefly, SceCtrlData*utility, int modepad) {
	 if(!modepad) {
		 if(utility->Lx > 230) freefly->camera.rotationx = 1.0f;
	     else if(utility->Lx < 60) freefly->camera.rotationx = -1.0f;
	     if(utility->Ly > 230) freefly->camera.rotationy = 1.0f;
	     else if(utility->Ly < 60) freefly->camera.rotationy = -1.0f;	 
	     if(utility->Lx > 230 || utility->Lx < 60) {
	         freefly->theta -= freefly->camera.rotationx*freefly->precision;;//on prend les coordonnes relative de la souris pour savoir o est la souris
	     }
	     else if(utility->Ly > 230 || utility->Ly < 60) {
	         freefly->phi -= freefly->camera.rotationy*freefly->precision;
	     }
	 }
	 else if(modepad) {
		 if(utility->Buttons & PSP_CTRL_CIRCLE) freefly->camera.rotationx = 1.0f;
	     else if(utility->Buttons & PSP_CTRL_SQUARE) freefly->camera.rotationx = -1.0f;
	     if(utility->Buttons & PSP_CTRL_CROSS) freefly->camera.rotationy = 1.0f;
	     else if(utility->Buttons & PSP_CTRL_TRIANGLE) freefly->camera.rotationy = -1.0f;	 
	     if(utility->Buttons & PSP_CTRL_CIRCLE || utility->Buttons & PSP_CTRL_SQUARE) {
	         freefly->theta -= freefly->camera.rotationx*freefly->precision;;//on prend les coordonnes relative de la souris pour savoir o est la souris
	     }
	     else if(utility->Buttons & PSP_CTRL_CROSS || utility->Buttons & PSP_CTRL_TRIANGLE) {
	         freefly->phi -= freefly->camera.rotationy*freefly->precision;
	     }
	 }   
	 
	 updateFreeFlyCamera(&(*freefly));//on met  jour la cible de la camra :p
}

void straightGestionFreeFlyCamera(FreeFlyCamera*freefly, SceCtrlData*utility, int modepad) {
	 if(!modepad) {
			 if(freefly->statutdeplacement == LIBERTY) {
		             if(utility->Buttons & PSP_CTRL_TRIANGLE) {
	                     freefly->camera.posx+=freefly->camera.ciblex*freefly->speed;
		                 freefly->camera.posy+=freefly->camera.cibley*freefly->speed;
		                 freefly->camera.posz+=freefly->camera.ciblez*freefly->speed;
	                 }
	                 if(utility->Buttons & PSP_CTRL_CROSS) {
	                     freefly->camera.posx-=freefly->camera.ciblex*freefly->speed;
		                 freefly->camera.posy-=freefly->camera.cibley*freefly->speed;
		                 freefly->camera.posz-=freefly->camera.ciblez*freefly->speed;
	                 }
		             if(utility->Buttons & PSP_CTRL_SQUARE) {
	                     freefly->camera.posx-=freefly->camera.lateralx*freefly->speed;
		                 freefly->camera.posy-=freefly->camera.lateraly*freefly->speed;
		                 freefly->camera.posz-=freefly->camera.lateralz*freefly->speed;
	                 }		
		             if(utility->Buttons & PSP_CTRL_CIRCLE) {
	                     freefly->camera.posx+=freefly->camera.lateralx*freefly->speed;
		                 freefly->camera.posy+=freefly->camera.lateraly*freefly->speed;
		                 freefly->camera.posz+=freefly->camera.lateralz*freefly->speed;
	                 }				 
	         }
	         else if(freefly->statutdeplacement == RESTRICT) {
		             if(utility->Buttons & PSP_CTRL_TRIANGLE) {
	                     freefly->camera.posx+=freefly->camera.ciblex*freefly->speed;
		                 freefly->camera.posy+=freefly->camera.cibley*freefly->speed;
		                 freefly->camera.posz = freefly->camera.posz;
	                 }
	                 if(utility->Buttons & PSP_CTRL_CROSS) {
	                     freefly->camera.posx-=freefly->camera.ciblex*freefly->speed;
		                 freefly->camera.posy-=freefly->camera.cibley*freefly->speed;
		                 freefly->camera.posz = freefly->camera.posz;
	                 }
		             if(utility->Buttons & PSP_CTRL_SQUARE) {
	                     freefly->camera.posx-=freefly->camera.lateralx*freefly->speed;
		                 freefly->camera.posy-=freefly->camera.lateraly*freefly->speed;
		                 freefly->camera.posz = freefly->camera.posz;
	                 }		
		             if(utility->Buttons & PSP_CTRL_CIRCLE) {
	                     freefly->camera.posx+=freefly->camera.lateralx*freefly->speed;
		                 freefly->camera.posy+=freefly->camera.lateraly*freefly->speed;
		                 freefly->camera.posz = freefly->camera.posz;
	                 }				 
	         }
	 }
	 else if(modepad) {
			 if(freefly->statutdeplacement == LIBERTY) {
		             if(utility->Ly < 60) {
	                     freefly->camera.posx+=freefly->camera.ciblex*freefly->speed;
		                 freefly->camera.posy+=freefly->camera.cibley*freefly->speed;
		                 freefly->camera.posz+=freefly->camera.ciblez*freefly->speed;
	                 }
	                 if(utility->Ly > 230) {
	                     freefly->camera.posx-=freefly->camera.ciblex*freefly->speed;
		                 freefly->camera.posy-=freefly->camera.cibley*freefly->speed;
		                 freefly->camera.posz-=freefly->camera.ciblez*freefly->speed;
	                 }
		             if(utility->Lx < 60) {
	                     freefly->camera.posx-=freefly->camera.lateralx*freefly->speed;
		                 freefly->camera.posy-=freefly->camera.lateraly*freefly->speed;
		                 freefly->camera.posz-=freefly->camera.lateralz*freefly->speed;
	                 }		
		             if(utility->Lx > 230) {
	                     freefly->camera.posx+=freefly->camera.lateralx*freefly->speed;
		                 freefly->camera.posy+=freefly->camera.lateraly*freefly->speed;
		                 freefly->camera.posz+=freefly->camera.lateralz*freefly->speed;
	                 }				 
	         }
	         else if(freefly->statutdeplacement == RESTRICT) {
		             if(utility->Ly < 60) {
	                     freefly->camera.posx+=freefly->camera.ciblex*freefly->speed;
		                 freefly->camera.posy+=freefly->camera.cibley*freefly->speed;
		                 freefly->camera.posz = freefly->camera.posz;
	                 }
	                 if(utility->Ly > 230) {
	                     freefly->camera.posx-=freefly->camera.ciblex*freefly->speed;
		                 freefly->camera.posy-=freefly->camera.cibley*freefly->speed;
		                 freefly->camera.posz = freefly->camera.posz;
	                 }
		             if(utility->Lx < 60) {
	                     freefly->camera.posx-=freefly->camera.lateralx*freefly->speed;
		                 freefly->camera.posy-=freefly->camera.lateraly*freefly->speed;
		                 freefly->camera.posz = freefly->camera.posz;
	                 }		
		             if(utility->Lx > 230) {
	                     freefly->camera.posx+=freefly->camera.lateralx*freefly->speed;
		                 freefly->camera.posy+=freefly->camera.lateraly*freefly->speed;
		                 freefly->camera.posz = freefly->camera.posz;
	                 }				 
	         }
	 }	     
	 updateFreeFlyCamera(&(*freefly));//on met  jour la cible vu par la camra avec les nouveaux angles
}
#endif

void setFreeFlyCameraPrecision(FreeFlyCamera*freefly, float precision) {
     freefly->precision = precision;
}

void setFreeFlyCameraSpeed(FreeFlyCamera*freefly, float speed) {
     freefly->speed = speed;
}

void enableFreeFlyCamera(FreeFlyCamera*freefly) {
     glMatrixMode(GL_MODELVIEW);
	 glLoadIdentity();
	 gluLookAt(freefly->camera.posx, freefly->camera.posy, freefly->camera.posz, freefly->camera.lookx, freefly->camera.looky, freefly->camera.lookz, 0, 0, 1);
}

void savePositionFreeFlyCamera(FreeFlyCamera*freefly) {
     freefly->camera.oldposx = freefly->camera.posx;
	 freefly->camera.oldposy = freefly->camera.posy;
	 freefly->camera.oldposz = freefly->camera.posz;
}

void restorePositionFreeFlyCamera(FreeFlyCamera*freefly) {
     freefly->camera.posx = freefly->camera.oldposx;
	 freefly->camera.posy = freefly->camera.oldposy;
	 freefly->camera.posz = freefly->camera.oldposz;
}

void saveLookFreeFlyCamera(FreeFlyCamera*freefly) {
	 freefly->camera.oldlookx = freefly->camera.lookx;
	 freefly->camera.oldlooky = freefly->camera.looky;
	 freefly->camera.oldlookz = freefly->camera.lookz;     
}

void restoreLookFreeFlyCamera(FreeFlyCamera*freefly) {
     freefly->camera.lookx = freefly->camera.oldlookx;
	 freefly->camera.looky = freefly->camera.oldlooky;
	 freefly->camera.lookz = freefly->camera.oldlookz;
}

void basicCamera(float positionx, float positiony, float positionz, float rotationx, float rotationy, float rotationz) {
	 glMatrixMode(GL_MODELVIEW);
	 glLoadIdentity();
	 glRotatef(rotationx, 1.0f, 0.0f, 0.0f);
	 glRotatef(rotationy, 0.0f, 1.0f, 0.0f);
	 glRotatef(rotationz, 0.0f, 0.0f, 1.0f);
	 glTranslatef(positionx, positiony, positionz);
}
