#ifndef __FREEFLYCAMERA_H__
#define __FREEFLYCAMERA_H__

#include "../varglob.h"

#define LIBERTY 0
#define RESTRICT 1

typedef struct CameraGestion {
     float posx;
	 float posy;
	 float posz;
	 float verticalx;//vecteur qui dfinit la vertical du monde pour faire le produit vectoriel par rapport au vecteur cible afin de dterminer o est la perpendiculaire du plan form par ce vecteur et le vecteur ciblepour faire les mouvements latraux :p
	 float verticaly;
	 float verticalz;
	 float lateralx;
	 float lateraly;
	 float lateralz;
	 float lateralnormalize;
	 float lookx;
	 float looky;
	 float lookz;
	 float ciblex;
	 float cibley;
	 float ciblez;
	 float oldposx;
	 float oldposy;
	 float oldposz;
	 float oldexc1posx;//pour une utilisation exceptionnelle
	 float oldexc1posy;
	 float oldexc1posz;	
	 float oldexc2posx;
	 float oldexc2posy;
	 float oldexc2posz;
	 float oldexc3posx;
	 float oldexc3posy;
	 float oldexc3posz;	
	 float oldexc4posx;
	 float oldexc4posy;
	 float oldexc4posz;	 
	 float oldlookx;
	 float oldlooky;
	 float oldlookz;
	 float rotationx;
	 float rotationy;
	 float rotationz;	 
} CameraGestion;

typedef struct FreeFlyCamera {
     CameraGestion camera;
	 float speed;
	 float precision;
	 float phi;
	 float theta;
	 int statutdeplacement;
	 int upstate;
	 int downstate;
	 int rightstate;
	 int leftstate;
}
FreeFlyCamera;

void updateFreeFlyCamera(FreeFlyCamera*freefly);
void initFreeFlyCamera(FreeFlyCamera*freefly, float positionx, float positiony, float positionz, float speed, float precision, int state);

#ifdef WINDOWS
     void setHideCursorMouseFreeFlyCamera(int hidecursor);
	 void mouseMotionGestionFreeFlyCamera(FreeFlyCamera*freefly, SDL_MouseMotionEvent*event);
	 void keyboardGestionFreeFlyCamera(FreeFlyCamera*freefly, SDL_KeyboardEvent*event);
	 void straightGestionFreeFlyCamera(FreeFlyCamera*freefly);
#endif
#ifdef PSP
     void mouseMotionGestionFreeFlyCamera(FreeFlyCamera*freefly, SceCtrlData*utility, int modepad);
	 void straightGestionFreeFlyCamera(FreeFlyCamera*freefly, SceCtrlData*utility, int modepad);
#endif

void setFreeFlyCameraPrecision(FreeFlyCamera*freefly, float precision);
void setFreeFlyCameraSpeed(FreeFlyCamera*freefly, float speed);
void enableFreeFlyCamera(FreeFlyCamera*freefly);
void savePositionFreeFlyCamera(FreeFlyCamera*freefly);
void restorePositionFreeFlyCamera(FreeFlyCamera*freefly);
void saveLookFreeFlyCamera(FreeFlyCamera*freefly);
void restoreLookFreeFlyCamera(FreeFlyCamera*freefly);
void basicCamera(float positionx, float positiony, float positionz, float rotationx, float rotationy, float rotationz);

#endif	 
