#ifndef __MD2LOADER_H__
#define __MD2LOADER_H__

#include "../varglob.h"

//ne pas modifier l'ordre et les variables des structures car sinon affichage des .md2 mauvais car les donnes du fichier .md2 seront stocks avec ces variables qui sont rangs dans l'ordre dans le fichier  
typedef struct Header {
     int ident;
	 int version;
	 
	 int texturewidth;
	 int textureheight;
	 
	 int framesize;
	 
	 int numbertexture;
	 int numbervertex;
	 int numbercoordtexture;
	 int numbertriangle;
	 int numberglcmd;
	 int numberframe;
	 
	 int offsettexture;
	 int offsetcoordtexture;
	 int offsettriangle;
	 int offsetframe;
	 int offsetglcmd;
	 int offsetend;
} Header;

typedef struct Textures {
     char name[64];
} Textures;

typedef struct Triangles {
     short vertex[3];
	 short xy[3];
} Triangles;

typedef struct CoordsTextures {
     unsigned short x;
	 unsigned short y;
} CoordsTextures;

typedef struct FramesVertex {
     unsigned char vertex[3];
	 unsigned char normalIndex;
} FramesVertex;

typedef struct Frames {
     float scale[3];
	 float translate[3];
	 char name[16];
	 FramesVertex*framevertex;
} Frames;

typedef struct MD2Model {
     Header header;
	 Textures*texture;
	 CoordsTextures*coordtexture;
	 Triangles*triangle;
	 Frames*frame;
	 float currentframe;
} MD2Model;

int loadMD2(MD2Model*md2, char*filename);
void MD2Display(MD2Model*md2, int currentframe, int texture);
void MD2Animation(MD2Model*md2, float speed, float debut, float fin);
void freeMD2(MD2Model*md2);

#endif
