#ifndef __OBJLOADER_H__
#define __OBJLOADER_H__

#include "../varglob.h"

typedef struct Vertexs {
     GLfloat x;
	 GLfloat y;
	 GLfloat z;
} Vertexs;

typedef struct orderVertexs {
     int v1;
	 int v2;
	 int v3;
} orderVertexs;

typedef struct Texcoords {
     float x;
	 float y;
} Texcoords;

typedef struct orderTexcoords {
     int t1;
	 int t2;
	 int t3;
} orderTexcoords;

typedef struct ModelObj {
     Vertexs*vertex;
	 orderVertexs*ordervertex;
	 Texcoords*texcoord;
	 orderTexcoords*ordertexcoord;
     int linereadvertex;
     int linereadtexcoord;
     int linereadordervtex;//position des coordonne de vertex et texture (f dans le fichier .obj)
     int lineobjvertex;
     int lineobjtexcoord;
     int lineobjordervtex;

	 int fordepart;

	 int linereadusemtl;
	 int lineobjusemtl;
	 int*usemtl;//variable permettant de stocker les diffrentes sous partie du fichier .obj pour mettre une texture sur une partie de l'objet et une autre sur l'autre ;)
	 int*usemtltexture;
	 int lineobjusemtltexture;
} ModelObj;

int readOBJ(ModelObj*modelobj, char*filename, int modeloadobj);
int loadOBJ(ModelObj*modelobj, char*filename, int modeloadobj);
void OBJDisplay(ModelObj*obj, int texture);
void freeOBJ(ModelObj*obj);

#endif
