#include "Tool.h"

int readLEVEL(Niveau*niveau, char*filename) {
     FILE*level = NULL;
	 level = fopen(filename, "r");
	 niveau->lineread = 1;
	 static char character[100];
	 if(level > 0) {
	     while(fgets(character, sizeof(character), level) > 0) {
		     if(character[0] != '/' && character[1] != '/') {
			     niveau->lineread++;
			 }
		 }
	 }
	 else return 0;
	 fclose(level);
	 return 1;
}
	 
int loadLEVEL(Niveau*niveau, char*filename) {
     
	 readLEVEL(&(*niveau), filename);
	 
     FILE*level = NULL;
	 level = fopen(filename, "r");
	 
	 int i;
	 niveau->linesetting = 1;
	 
	 niveau->setting = (float**)malloc(sizeof(float*)*niveau->lineread);
	 for(i=1; i<niveau->lineread; i++) {
	     niveau->setting[i] = (float*)malloc(sizeof(float)*12);//pour le moment 12 niveaux maximum
	 }
	 
	 static char character[100];
	 
	 if(level > 0) {	 
	     while(fgets(character, sizeof(character), level) > 0) {
	         if(character[0] != '/' && character[1] != '/') {
		         sscanf(character, "%f %f %f %f %f %f %f %f %f %f", &niveau->setting[niveau->linesetting][1], &niveau->setting[niveau->linesetting][2], &niveau->setting[niveau->linesetting][3], &niveau->setting[niveau->linesetting][4], &niveau->setting[niveau->linesetting][5], &niveau->setting[niveau->linesetting][6], &niveau->setting[niveau->linesetting][7], &niveau->setting[niveau->linesetting][8], &niveau->setting[niveau->linesetting][9], &niveau->setting[niveau->linesetting][10]);
		         niveau->linesetting++;
		     }
	     }
	 }
	 else return 0;
	 fclose(level);
	 return 1;
}
     
void freeLEVEL(Niveau*niveau) {
     free(niveau->setting);
}
     
int readMAP(Map*map, char*filename) {
     FILE*mapping = NULL;
	 mapping = fopen(filename, "r");
	 static int verification = 0;
	 map->lineread = 0;
	 map->numberread = 0;
	 
	 if(mapping > 0) {
	     while(!feof(mapping)) {
		     verification = fgetc(mapping);
			 if(verification != '\n') {
			     map->numberread++;
			 }
			 else if(verification == '\n') {
			     map->lineread++;
			 }
		 }
	 }
	 else return 0;
	 fclose(mapping);
	 return 1;
}
     
int loadMAP(Map*map, char*filename, int max, int min, int ecart) {
     FILE*mapping = NULL;
	 mapping = fopen(filename, "r");
	 
	 readMAP(&(*map), filename);
	 
	 if(mapping > 0) {
	     map->load = (int**)malloc(sizeof(int*)*map->lineread);
		 for(map->i=0; map->i<=map->lineread; map->i++) {
		     map->load[map->i] = (int*)malloc(sizeof(int)*map->numberread);
		 }
	     map->texture = (int**)malloc(sizeof(int*)*map->lineread);
		 for(map->i=0; map->i<=map->lineread; map->i++) {
		     map->texture[map->i] = (int*)malloc(sizeof(int)*map->numberread);
		 }		 
		 
		 static int verification = 0;
	     map->loadnumber = 0;
	     map->loadline = 0;
		 map->numbermax = 0;
		 
		 for(map->i=0; map->i<=map->lineread; map->i++) {   
             for(map->j=0; map->j<=map->numberread; map->j++) {		 
			     map->texture[map->i][map->j] = rand()%((max+(ecart/2))-(min-(ecart/2)))+(min-(ecart/2));
			     if(map->texture[map->i][map->j] < min || map->texture[map->i][map->j] > max) {
			         map->texture[map->i][map->j] = min;
			     }
		     }
		 }
		 
		 while(!feof(mapping)) {
		     verification = fgetc(mapping);
			 if(verification != '\n') {
				 map->load[map->loadline][map->loadnumber] = verification;
				 map->loadnumber++;
			 }
			 else if(verification == '\n') {
			     map->loadline++;
				 if(map->loadnumber > map->numbermax) map->numbermax = map->loadnumber;
				 map->loadnumber = 0;
				 map->linemax = map->loadline;
			 }		 
		 }
	 }
	 else return 0;
	 fclose(mapping);
	 return 1;
}
     
void freeMAP(Map*map) {
     free(map->load);
	 free(map->texture);
}
     
int IsMap(DirScan*dirscan, int i) {
     char tmp[64];
	 sprintf(tmp, "%s", dirscan[i].name);
	 if((tmp[strlen(tmp)-1] == 'p' || tmp[strlen(tmp)-1] == 'P') && (tmp[strlen(tmp)-2] == 'a' || tmp[strlen(tmp)-2] == 'A') && (tmp[strlen(tmp)-3] == 'm' || tmp[strlen(tmp)-3] == 'M')) {
	     return 1;
	 }
	 else return 0;
}
     
int ListFile(DirScan*dirscan, InfoScan*infoscan, char*dirname) {
     DIR*dir = opendir(dirname);
	 infoscan->count = 0;
	 if(dir != NULL) {
	     struct dirent*file;
		 while((file = readdir(dir)) != NULL) {
		     sprintf(dirscan[infoscan->count].name, file->d_name);
			 infoscan->count++;
			 if(infoscan->count > MAXFILE-1) infoscan->count = MAXFILE-1;
			 else if(infoscan->count < 0) infoscan->count = 0;
			 infoscan->total = infoscan->count;
		 }
	 }
	 else return 0;
	 closedir(dir);
	 return 1;
}

int Random(int min, int max) {
	 int ran = rand()%(max-min+1)+min;
	 return ran;
}
