#ifndef __TOOL_H__
#define __TOOL_H__

#include "../varglob.h"

typedef struct Niveau {
     int lineread;
	 int linesetting;
	 float**setting;
} Niveau;

typedef struct Map {
     int**load;
	 int lineread;
	 int numberread;
	 int loadline;
	 int loadnumber;
	 int numbermax;
	 int linemax;
	 float positioni;
	 float positionj;
	 int i;
	 int j;
	 int**texture;
	 float avancement;
} Map;

typedef struct DirScan {
     char name[64];
} DirScan;

typedef struct InfoScan { 
     int total;
	 int count;
	 int cursorcount;
	 int minpage;
	 int limitepage;
	 char src[125];
} InfoScan;

int readLEVEL(Niveau*niveau, char*filename);
int loadLEVEL(Niveau*niveau, char*filename);
void freeLEVEL(Niveau*niveau);
int readMAP(Map*map, char*filename);
int loadMAP(Map*map, char*filename, int max, int min, int ecart);
void freeMAP(Map*map);

int IsMap(DirScan*dirscan, int i);
int ListFile(DirScan*dirscan, InfoScan*infoscan, char*dirname);

int Random(int min, int max);

#endif
