#include "./PFST3DEngine/2D.h"
#include "./PFST3DEngine/Collision.h"
#include "./PFST3DEngine/Tool.h"
#include "./PFST3DEngine/MD2Loader.h"
#include "./PFST3DEngine/OBJLoader.h"
#include "./PFST3DEngine/Texture.h"
#include "./PFST3DEngine/Font.h"
#include "./PFST3DEngine/Timer.h"
#include "./PFST3DEngine/Fps.h"
#include "./PFST3DEngine/FreeFlyCamera.h"
#include "./PFST3DEngine/Frustum.h"
#include "./PFST3DEngine/Particule.h"
#include "varglob.h"

#ifdef PSP

PSP_MODULE_INFO("labKillHomer3D", 0, 1, 1); 
PSP_MAIN_THREAD_ATTR(THREAD_ATTR_USER | THREAD_ATTR_VFPU);

int exit_callback(int arg1, int arg2, void *common) {
     sceKernelExitGame();
     return 0;
}

int CallbackThread(SceSize args, void *argp) {
     int cbid;
     cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
     sceKernelRegisterExitCallback(cbid);
     sceKernelSleepThreadCB();
     return 0;
}

int SetupCallbacks(void) {
     int thid = 0;
     thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0xFA0, 0, 0);
     if(thid >= 0) {
         sceKernelStartThread(thid, 0, 0);
     }
     return thid;
}

#define exit(X) sceKernelExitGame();

#endif

#define MAX_ARME 30

int texture[23];
char info[100];

typedef struct Game {
	 int state;
	 float cursor;
	 float cursorbrowser;
	 int firstaccesslab;
	 int firstaccesslab2;
	 int normal;
	 int pad;
} Game;

typedef struct Monster {
     float x;
	 float y;
	 float z;
	 int direction;
	 int directionx;
	 int directiony;
	 int olddirection;
	 float oldx;
	 float oldy;
	 float oldz;
	 float oldexc1x;
	 float oldexc1y;
	 float oldexc1z;
	 float oldexc2x;
	 float oldexc2y;
	 float oldexc2z;
	 float oldexc3x;
	 float oldexc3y;
	 float oldexc3z;
	 float oldexc4x;
	 float oldexc4y;
	 float oldexc4z;
	 int aleatoire;
	 int update;
	 float speed;
	 float oldspeed;
	 float positioni;
	 float positionj;
	 int life;
	 int iskill;
	 int iswallleft;
	 int iswallright;
	 int iswallup;
	 int iswalldown;
	 int iswall;
	 int sfx;
	 int sfxcount;
	 int tempofirstpanik;
	 int tempoendpanik;
	 int enabletempopanik;
	 int countkillfirst;
	 int countkillend;
	 int delayfirstafterwall;
	 int delayendafterwall;
} Monster;

typedef struct Arme {
     float x;
	 float y;
	 float z;
	 float oldx;
	 float oldy;
	 float oldz;
	 float ciblex;
	 float cibley;
	 float ciblez;
	 float checkdistance;
	 int active;
} Arme;

typedef struct nameArme {
     Arme arme[MAX_ARME];
} nameArme;

typedef struct Splashscreen {
     float rotation;
	 float rebond;
	 float x;
	 float y;
	 float z;
	 int finish;
	 float twodx;
	 float twody;
	 int countfirst;
	 int countend;
} Splashscreen;

FreeFlyCamera freefly;
Frustum frustum;
FPSManager fps;
MD2Model monstre;
Map map;
Monster homer;
Game game;
nameParticule exitparticule;
nameParticule armeparticule;
nameArme arme;
DirScan dirscan[MAXFILE];
InfoScan infoscan;
Splashscreen splash;

void initGL(float width, float height) {
     glClearColor(0.0f, 0.0f, 0.0f, 1.0f);//Spcifie les valeurs rouge, vert, bleu, et alpha utilises quand les buffers de couleur sont effacs. Les valeurs initiales sont toutes 0.
	 glClearDepth(1.0f);
	 glDepthFunc(GL_LESS);
	 //glEnable(GL_LIGHTING);//on autorise l'clairage
	 glEnable(GL_LIGHT0);//on allume la premire lumire
	 glEnable(GL_DEPTH_TEST);//pour autoriser le Z-Buffer
	 glEnable(GL_TEXTURE_2D);
	 glShadeModel(GL_SMOOTH);//permet de demander  pspgl de remplir le polygone avec la couleur du dernier point specifi mais pour le dsactiver glShadeModel(GL_FLAT);
	 /*glMatrixMode(GL_TEXTURE);//pour modifier les matrix de la texture car la texture applique est  l'envers ;)
	 glLoadIdentity();
	 glRotatef(180.0f, 1.0f, 0.0f, 0.0f);//on fait une rotation de la texture de 180 sur l'axe x*/
	 glMatrixMode(GL_PROJECTION);
	 glLoadIdentity();
	 #ifdef WINDOWS
	 gluPerspective(70.0f, (GLfloat)width/(GLfloat)height, 0.01f, 1000.0f);
	 #endif
	 #ifdef PSP
	 gluPerspective(50.0f, (GLfloat)width/(GLfloat)height, 1.2f, 1000.0f);
	 #endif
	 glMatrixMode(GL_MODELVIEW);
}

void checkMur(Map*map, FreeFlyCamera*freefly, Monster*cible, Game*game, float minimum, Mix_Chunk*victoire, int channel) {
	 map->positioni = (freefly->camera.posx+3.0f)/6.0f;	 
	 map->positionj = (freefly->camera.posy+3.0f)/6.0f;
	 
     if(map->positioni >= 0 && map->positioni < map->linemax && map->positionj >= 0 && map->positionj < map->numbermax) {
	     if(map->load[(int)(map->positioni+minimum)][(int)(map->positionj)] == '0') {
             freefly->camera.oldexc1posx = freefly->camera.posx;
	         freefly->camera.oldexc1posy = freefly->camera.posy;
	         freefly->camera.oldexc1posz = freefly->camera.posz;
	     }
	     else if(map->load[(int)(map->positioni+minimum)][(int)(map->positionj)] == '1') {
		     freefly->camera.posz = freefly->camera.oldexc1posz;
		     freefly->camera.posy += (freefly->camera.ciblex+freefly->camera.cibley)*0.005f;
		     freefly->camera.posx = freefly->camera.oldexc1posx;
	     }	 
	     if(map->load[(int)(map->positioni-minimum)][(int)(map->positionj)] == '0') {
             freefly->camera.oldexc2posx = freefly->camera.posx;
	         freefly->camera.oldexc2posy = freefly->camera.posy;
	         freefly->camera.oldexc2posz = freefly->camera.posz;
	     }
	     else if(map->load[(int)(map->positioni-minimum)][(int)(map->positionj)] == '1') {
		     freefly->camera.posz = freefly->camera.oldexc2posz;
		     freefly->camera.posy += (freefly->camera.ciblex+freefly->camera.cibley)*0.005f;
		     freefly->camera.posx = freefly->camera.oldexc2posx;
	     }	
	     if(map->load[(int)(map->positioni)][(int)(map->positionj+minimum)] == '0') {
             freefly->camera.oldexc3posx = freefly->camera.posx;
	         freefly->camera.oldexc3posy = freefly->camera.posy;
	         freefly->camera.oldexc3posz = freefly->camera.posz;
	     }
	     else if(map->load[(int)(map->positioni)][(int)(map->positionj+minimum)] == '1') {
		     freefly->camera.posz = freefly->camera.oldexc3posz;
		     freefly->camera.posy = freefly->camera.oldexc3posy;
		     freefly->camera.posx += (freefly->camera.ciblex+freefly->camera.cibley)*0.005f;
	     }	
	     if(map->load[(int)(map->positioni)][(int)(map->positionj-minimum)] == '0') {
             freefly->camera.oldexc4posx = freefly->camera.posx;
	         freefly->camera.oldexc4posy = freefly->camera.posy;
	         freefly->camera.oldexc4posz = freefly->camera.posz;
	     }
	     else if(map->load[(int)(map->positioni)][(int)(map->positionj-minimum)] == '1') {
		     freefly->camera.posz = freefly->camera.oldexc4posz;
		     freefly->camera.posy = freefly->camera.oldexc4posy;
		     freefly->camera.posx += (freefly->camera.ciblex+freefly->camera.cibley)*0.005f;
	     }
		 
		 if(map->load[(int)(map->positioni)][(int)(map->positionj)] == 'S') {//pour la sortie :p
		     if(cible->iskill) {
			     #ifdef WINDOWS
				 freefly->leftstate = 0;
				 freefly->rightstate = 0;
				 freefly->upstate = 0;
				 freefly->downstate = 0;
				 #endif
				 game->firstaccesslab = 0;
				 Mix_PlayChannel(channel, victoire, 0);
				 game->state = 0;//check if homer is killed
			 }
		 }
	 }
	 else {
		 freefly->camera.posz = freefly->camera.oldexc1posz;
		 freefly->camera.posy = freefly->camera.oldexc1posy;
		 freefly->camera.posx = freefly->camera.oldexc1posx;
	 }
}

void initTir(nameArme*namearme, int maxarme, nameParticule*nameparticule, int maxparticule, float x, float y, float divspeed, float divactive, float divsize) {
     int i;
	 for(i=0; i<maxarme; i++) {
	     namearme->arme[i].x = 0.0f;
		 namearme->arme[i].y = 0.0f;
		 namearme->arme[i].z = 0.0f;
		 namearme->arme[i].active = 0;
		 namearme->arme[i].ciblex = 0.0f;
		 namearme->arme[i].cibley = 0.0f;
		 namearme->arme[i].ciblez = 0.0f;
		 namearme->arme[i].checkdistance = 0.0f;
	 }
	 
	 initParticule(*&nameparticule, MAX_PARTICULE, x, y, 0.0f, 1, divspeed, divactive, divsize);
}

#ifdef WINDOWS
/*void setTir(FreeFlyCamera*freefly, Arme*arme, Map*map, Monster*homer, SDL_MouseButtonEvent*event, float x, float y, float z, float size, int min, Mix_Chunk*sfxa, Mix_Chunk*sfxb, Mix_Chunk*sfxc, Mix_Chunk*sfxd, Mix_Chunk*sfxe, Mix_Chunk*sfxf, int channelsfx, Mix_Chunk*weapon, int channel) {
	 if(event->type == SDL_MOUSEBUTTONDOWN) {
	     if(event->button = SDL_BUTTON_LEFT) {
			 arme->oldciblex = freefly->camera.ciblex;
			 arme->oldcibley = freefly->camera.cibley;
			 arme->oldciblez = freefly->camera.ciblez;	
			 if(arme->statut == 0) Mix_PlayChannel(channel, weapon, 0);
			 arme->statut = 1;
			 arme->countfirst = SDL_GetTicks();//on prend la valeur du temps pass dans la boucle pour les sprite de l'explosion
			 if((arme->explosiondraw == 0) && (arme->posx == freefly->camera.posx && arme->posy == freefly->camera.posy && arme->posz == freefly->camera.posz)) arme->explosiondraw = 1;//on peut afficher l'explosion :p
		 }
	 }
	 
	 if(arme->statut == 0) {
	     arme->posx = freefly->camera.posx;
		 arme->posy = freefly->camera.posy;
		 arme->posz = freefly->camera.posz;
		 
	 }
	 else if(arme->statut == 1) {
	     if(arme->positioni > 0 && arme->positioni < map->linemax) arme->positioni = (float)((arme->posx+3.0f)/3.0f);//check si la balle ne heurte pas un mur :)
	     if(arme->positionj > 0 && arme->positionj < map->numbermax) arme->positionj = (float)((arme->posy+3.0f)/3.0f);		 
		 arme->posx+=arme->oldciblex;
		 arme->posy+=arme->oldcibley;
		 arme->posz+=arme->oldciblez;
		 //si a dpasse la taille de la map ou que a touche un mur alors on arrte le tir :p
		 if(arme->posx > map->linemax*6.0f || arme->posx < 0.0f) arme->statut = 0;//avec checkage mur donne: if(arme->posx > map->linemax*6.0f || arme->posx < 0.0f || map->load[arme->positioni][arme->positionj] == '1') arme->statut = 0;
		 if(arme->posy > map->numbermax*6.0f || arme->posy < 0.0f) arme->statut = 0;//if(arme->posy > map->numbermax*6.0f || arme->posy < 0.0f || map->load[arme->positioni][arme->positionj] == '1') arme->statut = 0;
		 if(arme->posz > 90.0f || arme->posz < -90.0f) arme->statut = 0;
		 arme->checkcollision = sqrt((arme->posx-x)*(arme->posx-x)+(arme->posy-y)*(arme->posy-y)+(arme->posz-z)*(arme->posz-z));
		 if(arme->checkcollision < size) {
			 homer->tempofirstpanik = SDL_GetTicks();
			 homer->sfx = rand()%(5);
			 //random misc if homer is attacked
			 if(homer->sfx == 0) Mix_PlayChannel(channelsfx, sfxa, 0);
			 else if(homer->sfx == 1) Mix_PlayChannel(channelsfx, sfxb, 0);
			 else if(homer->sfx == 2) Mix_PlayChannel(channelsfx, sfxc, 0);
			 else if(homer->sfx == 3) Mix_PlayChannel(channelsfx, sfxd, 0);
			 else if(homer->sfx == 4) Mix_PlayChannel(channelsfx, sfxe, 0);
			 else if(homer->sfx == 5) Mix_PlayChannel(channelsfx, sfxf, 0);					 
			 homer->enabletempopanik = 1;//on autorise le compteur  se mettre en route :)
			 homer->life-=10;
			 arme->statut = 0;
		 }
	 }
	 
	 if(homer->enabletempopanik == 0) {
				     homer->oldspeed = homer->speed;
					 homer->olddirection = homer->direction;
	 }
	 else if(homer->enabletempopanik == 1) {
				     homer->tempoendpanik = SDL_GetTicks()-homer->tempofirstpanik;
					 if(homer->tempoendpanik < 1000) {
					     homer->speed = 2.5f;//the speed is multiplied by twenty :D just to destabilize the player
						 homer->direction = rand()%(5-1)+1;
					 }
					 else if(homer->tempoendpanik >= 1000) {
						 homer->speed = homer->oldspeed;
						 homer->direction = homer->olddirection;
						 homer->tempofirstpanik = 0;
						 homer->enabletempopanik = 0;
						 homer->tempoendpanik = 0;
					 }
	 }	
	 
	 if(arme->explosiondraw == 1) {
		 if(arme->countfirst+40 > SDL_GetTicks()) arme->explosionindex = min;
		 else if(arme->countfirst+80 > SDL_GetTicks()) arme->explosionindex = min+1;
		 else if(arme->countfirst+120 > SDL_GetTicks()) arme->explosionindex = min+2;
		 else if(arme->countfirst+160 > SDL_GetTicks()) arme->explosionindex = min+3;
		 else if(arme->countfirst+200 > SDL_GetTicks()) arme->explosiondraw = 0;
	 }
}

SDL_Event event;*/

void setTir(FreeFlyCamera*freefly, nameArme*name, Map*map, Monster*cible, nameParticule*nameparticule, SDL_MouseButtonEvent*event, float ciblex, float cibley, float ciblez, float ciblesize, float divspeed, float divactive, float divsize, int texture, float x, float y, Mix_Chunk*sfxa, Mix_Chunk*sfxb, Mix_Chunk*sfxc, Mix_Chunk*sfxd, Mix_Chunk*sfxe, Mix_Chunk*sfxf, int channelsfx, Mix_Chunk*weapon, int channelweapon) {
     int i;
	 static int currentarme = 0;
	 if(event->type == SDL_MOUSEBUTTONDOWN) {
	     if(event->button == SDL_BUTTON_LEFT) {
		     name->arme[currentarme].x = freefly->camera.posx;
			 name->arme[currentarme].y = freefly->camera.posy;
			 name->arme[currentarme].z = freefly->camera.posz;
			 name->arme[currentarme].ciblex = freefly->camera.ciblex;
			 name->arme[currentarme].cibley = freefly->camera.cibley;
			 name->arme[currentarme].ciblez = freefly->camera.ciblez;
		     name->arme[currentarme].active = 1;
			 displayParticule(*&nameparticule, MAX_PARTICULE, 1, divspeed, divactive, divsize, 1, texture);
			 Mix_PlayChannel(channelweapon, weapon, 0);
			 currentarme++;
			 currentarme%=MAX_ARME;
		 }
		 else {
		     initParticule(*&nameparticule, MAX_PARTICULE, x, y, 0.0f, 1, divspeed, divactive, divsize);
		 }
	 }
	 
	 for(i=0; i<MAX_ARME; i++) {
	     if(name->arme[i].active == 1) {
		     name->arme[i].x += name->arme[i].ciblex;
			 name->arme[i].y += name->arme[i].cibley;
			 name->arme[i].z += name->arme[i].ciblez;
			 if(name->arme[i].x > map->linemax*6.0f || name->arme[i].x < 0.0f) name->arme[i].active = 0;
			 if(name->arme[i].y > map->numbermax*6.0f || name->arme[i].y < 0.0f) name->arme[i].active = 0;
			 if(name->arme[i].z > 90.0f || name->arme[i].z < -90.0f) name->arme[i].active = 0;
			 name->arme[i].checkdistance = sqrt((name->arme[i].x-ciblex)*(name->arme[i].x-ciblex) + (name->arme[i].y-cibley)*(name->arme[i].y-cibley) + (name->arme[i].z-ciblez)*(name->arme[i].z-ciblez));
			 if((name->arme[i].checkdistance <= ciblesize+0.05f) && (!cible->iskill)) {//0.05f size of 1 ball
			     cible->sfx = rand()%(5+0)+0;			 
				 //random misc if the target is attacked :)
				 if(cible->sfx == 0) Mix_PlayChannel(channelsfx, sfxa, 0);
				 else if(cible->sfx == 1) Mix_PlayChannel(channelsfx, sfxb, 0);
				 else if(cible->sfx == 2) Mix_PlayChannel(channelsfx, sfxc, 0);
				 else if(cible->sfx == 3) Mix_PlayChannel(channelsfx, sfxd, 0);
				 else if(cible->sfx == 4) Mix_PlayChannel(channelsfx, sfxe, 0);
				 else if(cible->sfx == 5) Mix_PlayChannel(channelsfx, sfxf, 0);
				 
				 /*if(name->arme[i].x-freefly->camera.posx > 3.0f) {
					 cible->directionx = 1;
					 cible->directiony = 0;
				 }
				 else if(name->arme[i].x-freefly->camera.posx < -3.0f) {
					 cible->directionx = 2;
					 cible->directiony = 0;
				 }
				 if(name->arme[i].y-freefly->camera.posy > 3.0f) {
					 cible->directiony = 3;
					 cible->directionx = 0;
				 }
				 else if(name->arme[i].y-freefly->camera.posy < -3.0f) {
					 cible->directiony = 4;
					 cible->directionx = 0;
				 }*/
				 cible->tempofirstpanik = SDL_GetTicks();
				 cible->enabletempopanik = 1;
				 if(cible->life > 0) cible->life-=1;
				 else if (cible->life <= 0) cible->iskill = 1;
				 name->arme[i].active = 0;
			 }
		 }
		 else if(name->arme[i].active = 0) {
		     name->arme[i].x = freefly->camera.posx;
			 name->arme[i].y = freefly->camera.posy;
			 name->arme[i].z = freefly->camera.posz;
		 }	 
	 }
	 
	 if(cible->enabletempopanik) {
	     cible->tempoendpanik = SDL_GetTicks()-cible->tempofirstpanik;
		 if(cible->tempoendpanik > 2000) {
		     cible->enabletempopanik = 0;
		 }
	 }
	 
	 /*if(!cible->iskill) {		 
		//cible->speed = 2.5f;//to destabilize the player
			 if(cible->direction == (cible->directionx+cible->directiony)) {
				 cible->direction = cible->directionx+cible->directiony;
			 }	
			 else if(cible->direction != (cible->directionx+cible->directiony)) {//if the player change the direction
				 if(cible->iswallup == 0 && cible->iswalldown == 0 || cible->iswallright == 0 && cible->iswallleft == 0) {
				     if(cible->directiony == 0) {
				         cible->directionx = rand()%(3-1)+1;
				     }   
				     else if(cible->directionx == 0) {
				         cible->directiony = rand()%(5-3)+3;
				     }
				 }
				 if(cible->iswallup == 1 || cible->iswalldown == 1 || cible->iswallright == 1 || cible->iswallleft == 1) {
				     if(cible->directiony == 0) {
				         cible->directionx = rand()%(5-3)+3;
				     }
				     else if(cible->directionx == 0) {
				         cible->directiony = rand()%(3-1)+1;
				     }
				 }
				 cible->direction = cible->directionx+cible->directiony;
			 }
	 }*/
	 
	 if(cible->iskill) {//si la cible est morte on arrete de le faire crier :p
	     Mix_HaltChannel(channelsfx);
	 }	 
}

SDL_Event event;
#endif

#ifdef PSP
/*void setTir(FreeFlyCamera*freefly, Arme*arme, Map*map, Monster*homer, SceCtrlData*utility, float x, float y, float z, float size, int min, Mix_Chunk*sfxa, Mix_Chunk*sfxb, Mix_Chunk*sfxc, Mix_Chunk*sfxd, Mix_Chunk*sfxe, Mix_Chunk*sfxf, int channelsfx, Mix_Chunk*weapon, int channel) {
	 static int oldpad = 0;
	 if(oldpad != utility->Buttons) {
	     if((utility->Buttons & PSP_CTRL_RTRIGGER) && (arme->posx == freefly->camera.posx && arme->posy == freefly->camera.posy && arme->posz == freefly->camera.posz)) {			     
			 arme->oldciblex = freefly->camera.ciblex;
			 arme->oldcibley = freefly->camera.cibley;
			 arme->oldciblez = freefly->camera.ciblez;
			 if(arme->statut == 0) Mix_PlayChannel(channel, weapon, 0);
			 arme->statut = 1;
			 arme->countfirst = SDL_GetTicks();//on prend la valeur du temps pass dans la boucle pour les sprite de l'explosion			 
			 if((arme->explosiondraw == 0) && (arme->posx == freefly->camera.posx && arme->posy == freefly->camera.posy && arme->posz == freefly->camera.posz)) arme->explosiondraw = 1;//on peut afficher l'explosion :p
	     }
	 }
	 oldpad = utility->Buttons;
	 
	 if(arme->statut == 0) {
	     arme->posx = freefly->camera.posx;
		 arme->posy = freefly->camera.posy;
		 arme->posz = freefly->camera.posz;
	 }
	 else if(arme->statut == 1) {
		 //if(arme->positioni > 0 && arme->positioni < map->linemax) arme->positioni = (float)((arme->posx+3.0f)/3.0f);//check si la balle ne heurte pas un mur :)
	     //if(arme->positionj > 0 && arme->positionj < map->numbermax) arme->positionj = (float)((arme->posy+3.0f)/3.0f);		 
		 arme->posx+=arme->oldciblex*3.0f;
		 arme->posy+=arme->oldcibley*3.0f;
		 arme->posz+=arme->oldciblez*3.0f;
		 if(arme->posx > map->linemax*6.0f || arme->posx < 0.0f) arme->statut = 0;
		 if(arme->posy > map->numbermax*6.0f || arme->posy < 0.0f) arme->statut = 0;
		 if(arme->posz > 90.0f || arme->posz < -90.0f) arme->statut = 0;
		 arme->checkcollision = sqrt((arme->posx-x)*(arme->posx-x)+(arme->posy-y)*(arme->posy-y)+(arme->posz-z)*(arme->posz-z));
		 if(arme->checkcollision < size) {
			 homer->tempofirstpanik = SDL_GetTicks();
			 homer->sfx = rand()%(5);
			 //random misc if homer is attacked
			 if(homer->sfx == 0) Mix_PlayChannel(channelsfx, sfxa, 0);
			 else if(homer->sfx == 1) Mix_PlayChannel(channelsfx, sfxb, 0);
			 else if(homer->sfx == 2) Mix_PlayChannel(channelsfx, sfxc, 0);
			 else if(homer->sfx == 3) Mix_PlayChannel(channelsfx, sfxd, 0);
			 else if(homer->sfx == 4) Mix_PlayChannel(channelsfx, sfxe, 0);
			 else if(homer->sfx == 5) Mix_PlayChannel(channelsfx, sfxf, 0);					 
			 homer->enabletempopanik = 1;//on autorise le compteur  se mettre en route :)
			 homer->life-=10;
			 arme->statut = 0;
		 }
	 }
	 
	 if(homer->enabletempopanik == 0) {
				     homer->oldspeed = homer->speed;
					 homer->olddirection = homer->direction;
	 }
	 else if(homer->enabletempopanik == 1) {
				     homer->tempoendpanik = SDL_GetTicks()-homer->tempofirstpanik;
					 if(homer->tempoendpanik < 1000) {
					     homer->speed = 2.5f;//the speed is multiplied by twenty :D just to destabilize the player
						 homer->direction = rand()%(5-1)+1;
					 }
					 else if(homer->tempoendpanik >= 1000) {
						 homer->speed = homer->oldspeed;
						 homer->direction = homer->olddirection;
						 homer->tempofirstpanik = 0;
						 homer->enabletempopanik = 0;
						 homer->tempoendpanik = 0;
					 }
	 }	 
	 
	 if(arme->explosiondraw == 1) {
		 if(arme->countfirst+110 > SDL_GetTicks()) arme->explosionindex = min;
		 else if(arme->countfirst+220 > SDL_GetTicks()) arme->explosionindex = min+1;
		 else if(arme->countfirst+330 > SDL_GetTicks()) arme->explosionindex = min+2;
		 else if(arme->countfirst+440 > SDL_GetTicks()) arme->explosionindex = min+3;
		 else if(arme->countfirst+550 > SDL_GetTicks()) arme->explosiondraw = 0;
	 }
}*/

void setTir(FreeFlyCamera*freefly, nameArme*name, Map*map, Monster*cible, nameParticule*nameparticule, SceCtrlData*utility, float ciblex, float cibley, float ciblez, float ciblesize, float divspeed, float divactive, float divsize, int texture, float x, float y, Mix_Chunk*sfxa, Mix_Chunk*sfxb, Mix_Chunk*sfxc, Mix_Chunk*sfxd, Mix_Chunk*sfxe, Mix_Chunk*sfxf, int channelsfx, Mix_Chunk*weapon, int channelweapon) {
     int i;
	 static int currentarme = 0;
	 if(utility->Buttons & PSP_CTRL_RTRIGGER) {
		     name->arme[currentarme].x = freefly->camera.posx;
			 name->arme[currentarme].y = freefly->camera.posy;
			 name->arme[currentarme].z = freefly->camera.posz;
			 name->arme[currentarme].ciblex = freefly->camera.ciblex;
			 name->arme[currentarme].cibley = freefly->camera.cibley;
			 name->arme[currentarme].ciblez = freefly->camera.ciblez;
		     name->arme[currentarme].active = 1;
			 displayParticule(*&nameparticule, MAX_PARTICULE, 1, divspeed, divactive, divsize, 1, texture);
			 Mix_PlayChannel(channelweapon, weapon, 0);
			 currentarme++;
			 currentarme%=MAX_ARME;
	 }
	 else {
	         initParticule(*&nameparticule, MAX_PARTICULE, x, y, 0.0f, 1, divspeed, divactive, divsize);
	 }
	 
	 for(i=0; i<MAX_ARME; i++) {
	     if(name->arme[i].active == 1) {
		     name->arme[i].x += name->arme[i].ciblex*5.0f;
			 name->arme[i].y += name->arme[i].cibley*5.0f;
			 name->arme[i].z += name->arme[i].ciblez*5.0f;
			 if(name->arme[i].x > map->linemax*6.0f || name->arme[i].x < 0.0f) name->arme[i].active = 0;
			 if(name->arme[i].y > map->numbermax*6.0f || name->arme[i].y < 0.0f) name->arme[i].active = 0;
			 if(name->arme[i].z > 90.0f || name->arme[i].z < -90.0f) name->arme[i].active = 0;
			 name->arme[i].checkdistance = sqrt((name->arme[i].x-ciblex)*(name->arme[i].x-ciblex) + (name->arme[i].y-cibley)*(name->arme[i].y-cibley) + (name->arme[i].z-ciblez)*(name->arme[i].z-ciblez));
			 if((name->arme[i].checkdistance <= ciblesize+0.05f) && (!cible->iskill)) {//0.05f size of 1 ball
			     cible->sfx = rand()%(5+0)+0;			 
				 //random misc if the target is attacked :)
				 if(cible->sfx == 0) Mix_PlayChannel(channelsfx, sfxa, 0);
				 else if(cible->sfx == 1) Mix_PlayChannel(channelsfx, sfxb, 0);
				 else if(cible->sfx == 2) Mix_PlayChannel(channelsfx, sfxc, 0);
				 else if(cible->sfx == 3) Mix_PlayChannel(channelsfx, sfxd, 0);
				 else if(cible->sfx == 4) Mix_PlayChannel(channelsfx, sfxe, 0);
				 else if(cible->sfx == 5) Mix_PlayChannel(channelsfx, sfxf, 0);
				 
				 /*if(name->arme[i].x-freefly->camera.posx > 3.0f) {
					 cible->directionx = 1;
					 cible->directiony = 0;
				 }
				 else if(name->arme[i].x-freefly->camera.posx < -3.0f) {
					 cible->directionx = 2;
					 cible->directiony = 0;
				 }
				 if(name->arme[i].y-freefly->camera.posy > 3.0f) {
					 cible->directiony = 3;
					 cible->directionx = 0;
				 }
				 else if(name->arme[i].y-freefly->camera.posy < -3.0f) {
					 cible->directiony = 4;
					 cible->directionx = 0;
				 }*/
				 cible->tempofirstpanik = SDL_GetTicks();
				 cible->enabletempopanik = 1;
				 if(cible->life > 0) cible->life-=1;
				 else if (cible->life <= 0) cible->iskill = 1;
				 name->arme[i].active = 0;
			 }
		 }
		 else if(name->arme[i].active = 0) {
		     name->arme[i].x = freefly->camera.posx;
			 name->arme[i].y = freefly->camera.posy;
			 name->arme[i].z = freefly->camera.posz;
		 }	 
	 }
	 
	 if(cible->enabletempopanik) {
	     cible->tempoendpanik = SDL_GetTicks()-cible->tempofirstpanik;
		 if(cible->tempoendpanik > 2000) {
		     cible->enabletempopanik = 0;
		 }
	 }
	 
	 /*if(!cible->iskill) {		 
		//cible->speed = 2.5f;//to destabilize the player
			 if(cible->direction == (cible->directionx+cible->directiony)) {
				 cible->direction = cible->directionx+cible->directiony;
			 }	
			 else if(cible->direction != (cible->directionx+cible->directiony)) {//if the player change the direction
				 if(cible->iswallup == 0 && cible->iswalldown == 0 || cible->iswallright == 0 && cible->iswallleft == 0) {
				     if(cible->directiony == 0) {
				         cible->directionx = rand()%(3-1)+1;
				     }   
				     else if(cible->directionx == 0) {
				         cible->directiony = rand()%(5-3)+3;
				     }
				 }
				 if(cible->iswallup == 1 || cible->iswalldown == 1 || cible->iswallright == 1 || cible->iswallleft == 1) {
				     if(cible->directiony == 0) {
				         cible->directionx = rand()%(5-3)+3;
				     }
				     else if(cible->directionx == 0) {
				         cible->directiony = rand()%(3-1)+1;
				     }
				 }
				 cible->direction = cible->directionx+cible->directiony;
			 }
	 }*/
	 
	 if(cible->iskill) {//si la cible est morte on arrete de le faire crier :p
	     Mix_HaltChannel(channelsfx);
	 }
}

SceCtrlData pad;
#endif

void splashscreen(Game*game, Splashscreen*splash, int texture, int texture2, Mix_Chunk*sfx, int channel) {
     glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	 glMatrixMode(GL_MODELVIEW);
	 glLoadIdentity();
	 gluLookAt(0.0f, 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f);
	 
	 int i;
	 int j;
	 
	 #ifdef WINDOWS
	 splash->y += 0.05f;
	 splash->rotation += 0.75f;
	 #endif
	 #ifdef PSP
	 splash->y += 0.1f;
	 splash->rotation += 1.75f;
	 #endif
	 if(splash->y >= 15.0f) {
		 splash->finish = 1;
	 }
	 else {
	     splash->countfirst = SDL_GetTicks();
	 }	 
	 
	 if(!splash->finish) {
	     for(i=-7; i<7; i++) {
	         for(j=-7; j<7; j++) {
	             glPushMatrix();
	             //glDisable(GL_LIGHTING);
	             glDisable(GL_TEXTURE_2D);
	             glTranslatef(i*2.0f, -15.0f+Random(-3, 3)+splash->y, j*2.0f);
	             glRotatef(splash->rotation, 0.0f, 0.0f, 1.0f);
	             glBegin(GL_TRIANGLE_STRIP);
	             glColor3ub(Random(0, 255), Random(0, 255), Random(0, 255));
	             glVertex3f(1.0f, 1.0f, 1.0f);
	             glVertex3f(1.0f, -1.0f, 1.0f);
	             glVertex3f(1.0f, 1.0f, -1.0f);
	             glVertex3f(1.0f, -1.0f, -1.0f);
	             glEnd();
	             
	             glBegin(GL_TRIANGLE_STRIP);
	             glColor3ub(Random(0, 255), Random(0, 255), Random(0, 255));
	             glVertex3f(-1.0f, 1.0f, 1.0f);
	             glVertex3f(-1.0f, -1.0f, 1.0f);
	             glVertex3f(-1.0f, 1.0f, -1.0f);
	             glVertex3f(-1.0f, -1.0f, -1.0f);
	             glEnd();
	             
	             glBegin(GL_TRIANGLE_STRIP);
	             glColor3ub(Random(0, 255), Random(0, 255), Random(0, 255));
	             glVertex3f(-1.0f, -1.0f, 1.0f);
	             glVertex3f(1.0f, -1.0f, 1.0f);
	             glVertex3f(-1.0f, -1.0f, -1.0f); 
	             glVertex3f(1.0f, -1.0f, -1.0f);
	             glEnd();
	             
	             glEnable(GL_TEXTURE_2D);
	             glColor3f(1.0f, 1.0f, 1.0f);
	             glBindTexture(GL_TEXTURE_2D, texture); 
	             glBegin(GL_TRIANGLE_STRIP);
	             glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, 1.0f, 1.0f);
	             glTexCoord2f(0.0f, 0.0f); glVertex3f(1.0f, 1.0f, 1.0f);
	             glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f, 1.0f, -1.0f); 
	             glTexCoord2f(0.0f, 1.0f); glVertex3f(1.0f, 1.0f, -1.0f);
	             glEnd();	 
	             glPopMatrix();
	         }
	     }
	 }
	 
	 #ifdef WINDOWS
	 glEnable2D(WIDTH_SCREEN, HEIGHT_SCREEN, -1, 1);
	 writeSDLImageFont(texture2, "Press Backspace to skip this animation", 12.0f, 2.0f, 2.0f, 1, 0.4f);
	 #endif
	 
	 if(splash->finish) {
	     splash->countend = SDL_GetTicks()-splash->countfirst;
		 
		 if(splash->countend <= 2000) {
			 if(splash->twodx < 480.0f) splash->twodx+=20.0f;
		     if(splash->twody < 272.0f) splash->twody+=11.4f;
			 
		     glEnable2D(WIDTH_SCREEN, HEIGHT_SCREEN, -1, 1);
		     glBindTexture(GL_TEXTURE_2D, texture);
		     glBegin(GL_TRIANGLE_STRIP);
		     glTexCoord2f(0.0f, 0.0f); glVertex2f(-WIDTH_SCREEN+splash->twodx, -HEIGHT_SCREEN+splash->twody);
		     glTexCoord2f(0.0f, 1.0f); glVertex2f(-WIDTH_SCREEN+splash->twodx, splash->twody);
		     glTexCoord2f(1.0f, 0.0f); glVertex2f(splash->twodx, -HEIGHT_SCREEN+splash->twody);
		     glTexCoord2f(1.0f, 1.0f); glVertex2f(splash->twodx, splash->twody);
	         glEnd();
		 }
		 else if(splash->countend > 2000) {
	         #ifdef WINDOWS
		     Mix_PlayChannel(channel, sfx, -1);
		     #endif
		     #ifdef PSP
		     MP3_Play();
		     #endif
		     game->state = 0;	
		 }	 
     }
	 
	 /*glBindTexture(GL_TEXTURE_2D, texture2);
	 glBegin(GL_TRIANGLE_STRIP);
	 glTexCoord2f(0.0f, 0.0f); glVertex3f(-12.0f, -1.0f, -1.0f);
	 glTexCoord2f(15.0f, 0.0f); glVertex3f(12.0f, -1.0f, -1.0f);
	 glTexCoord2f(0.0f, 15.0f); glVertex3f(-12.0f, -15.0f, -1.0f); 
	 glTexCoord2f(15.0f, 15.0f); glVertex3f(12.0f, -15.0f, -1.0f);	
	 glEnd();
	 
	 glBindTexture(GL_TEXTURE_2D, texture3);
	 glBegin(GL_TRIANGLE_STRIP);
	 glTexCoord2f(1.0f, 0.0f); glVertex3f(-12.0f, -15.0f, 6.5f);
	 glTexCoord2f(0.0f, 0.0f); glVertex3f(12.0f, -15.0f, 6.5f);
	 glTexCoord2f(1.0f, 1.0f); glVertex3f(-12.0f, -15.0f, -1.0f); 
	 glTexCoord2f(0.0f, 1.0f); glVertex3f(12.0f, -15.0f, -1.0f);	
	 glEnd();*/
	 
	 #ifdef PSP
	 glEnable2D(WIDTH_SCREEN, HEIGHT_SCREEN, -1, 1);
	 writeSDLImageFont(texture2, "Press Start to skip this animation", 12.0f, 2.0f, 2.0f, 1, 0.4f);
	 #endif
	 glDisable2D();
	 
	 //glEnable(GL_LIGHTING);
	 glColor3f(1.0f, 1.0f, 1.0f);
}

void Display(Mix_Chunk*sfxa, Mix_Chunk*sfxb, Mix_Chunk*sfxc, Mix_Chunk*sfxd, Mix_Chunk*sfxe, Mix_Chunk*sfxf, int channelsfx, Mix_Chunk*weapon, int channelweapon) {
     int i;
	 int j;
	 
	 glDisable(GL_ALPHA_TEST);
	 glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);//on nettoie l'cran et le Z-Buffer (==depth buffer)
	 
	 enableFreeFlyCamera(&freefly);
	 
	 /*#ifdef WINDOWS
	     float spotposition[4] = {freefly.camera.posx, freefly.camera.posy, freefly.camera.posz+10.0f, 1.0f};//1.0f car on veut une lumire de position:)
	 #endif
	 #ifdef PSP
	     float spotposition[4] = {freefly.camera.posx, freefly.camera.posy, freefly.camera.posz+80.0f, 1.0f};//1.0f car on veut une lumire de position:)
	 #endif
	 
	 if(game.normal) {
		 glEnable(GL_LIGHTING);
	     glLightfv(GL_LIGHT0, GL_POSITION, spotposition);		 
	 }*/
	 
	 if(!game.normal) {
	     freefly.camera.posz = 15.0f;//we go to the sky mode
	 }
	 else if(game.normal) {
	     freefly.camera.posz = 0.0f;
	 }
	 
	 //updateExtractPlaneFrustum(&frustum);
	 
	 glPushMatrix();
		     glTranslatef(homer.x, homer.y, homer.z);
			 
			 /*if(!homer.iskill) {
			     //un peu d'alatoire... pour avoir plus de hasard dans la gestion des dplacement de homer :p
			     homer.aleatoire = rand()%(100000-0)+0;
			     homer.update++;
			     homer.update%=100000;
			     
			     if(homer.update == homer.aleatoire) {
			         homer.direction = Random(1, 4);
			     }
			 }*/
			 
			 if(homer.direction == 1) {
				 if(!homer.iskill) {
				     homer.x+=homer.speed;
				 }
			     glRotatef(180.0f, 0.0f, 0.0f, 1.0f);	 
			 } 
			 if(homer.direction == 2) {
				 if(!homer.iskill) {
				     homer.x-=homer.speed;
				 }
			     glRotatef(0.0f, 0.0f, 0.0f, 1.0f);
	         }			 
			 if(homer.direction == 3) {	     
				 if(!homer.iskill) {
				     homer.y+=homer.speed;
				 }
			     glRotatef(270.0f, 0.0f, 0.0f, 1.0f);
			 }
			 if(homer.direction == 4) {
				 if(!homer.iskill) {
				     homer.y-=homer.speed;
				 }
				 glRotatef(90.0f, 0.0f, 0.0f, 1.0f);
			 }
			 glRotatef(180.0f, 0.0f, 0.0f, 1.0f);
			 
			 if(!homer.iswallup && !homer.iswalldown && !homer.iswallleft && !homer.iswallright) {	 
                 homer.delayendafterwall = SDL_GetTicks()-homer.delayfirstafterwall;
				 if(freefly.camera.ciblex > 0.5f) {
					 homer.directionx = 1;
					 homer.directiony = 0;
				 }
				 else if(freefly.camera.ciblex < -0.5f) {
					 homer.directionx = 2;
					 homer.directiony = 0;
				 }
				 if(freefly.camera.cibley > 0.5f) {
					 homer.directiony = 3;
					 homer.directionx = 0;
				 }
				 else if(freefly.camera.cibley < -0.5f) {
					 homer.directiony = 4;
					 homer.directionx = 0;
				 }	
				 
			     if(((homer.x+homer.y) > (freefly.camera.posx+freefly.camera.posy-50.0f) && (homer.x+homer.y) < (freefly.camera.posx+freefly.camera.posy+50.0f)) && homer.delayendafterwall > 100) {
				     if(!homer.iskill) {
						 homer.direction = homer.directionx+homer.directiony;
					 }
			     }	
			 }
			 else {
			     homer.delayfirstafterwall = SDL_GetTicks();
			 }
			 
			 //gestion des collisions monstres avec le labyrinthe :p
			 homer.positioni = (homer.x+3.0f)/6.0f;
			 homer.positionj = (homer.y+3.0f)/6.0f;		
			 
			 if(homer.positioni >= 0 && homer.positioni < map.linemax && homer.positionj >= 0 && homer.positionj < map.numbermax) {
			     if(map.load[(int)(homer.positioni+0.20f)][(int)(homer.positionj)] != '1') {
				     homer.oldexc1x = homer.x;
				     homer.oldexc1y = homer.y;
				     homer.oldexc1z = homer.z;
					 homer.olddirection = homer.direction;
					 homer.iswallright = 0;
			     }
		         else if(map.load[(int)(homer.positioni+0.20f)][(int)(homer.positionj)] == '1') {
				     homer.x = homer.oldexc1x;
				     homer.y = homer.oldexc1y;
				     homer.z = homer.oldexc1z;
					 homer.iswallright = 1;
				     if(!homer.iskill) {
						 if(homer.olddirection == 1 || homer.olddirection == 2) {
						     homer.direction = rand()%(5-3)+3;
						 }
						 else if(homer.olddirection == 3 || homer.olddirection == 4) {
						     homer.direction = rand()%(3-1)+1;
						 }
					 }
			     }	
			     if(map.load[(int)(homer.positioni)][(int)(homer.positionj+0.20f)] != '1') {
				     homer.oldexc2x = homer.x;
				     homer.oldexc2y = homer.y;
				     homer.oldexc2z = homer.z;
					 homer.olddirection = homer.direction;
					 homer.iswallup = 0;
			     }
		         else if(map.load[(int)(homer.positioni)][(int)(homer.positionj+0.20f)] == '1') {
				     homer.x = homer.oldexc2x;
				     homer.y = homer.oldexc2y;
				     homer.z = homer.oldexc2z;
					 homer.iswallup = 1;
				     if(!homer.iskill) {
						 if(homer.olddirection == 1 || homer.olddirection == 2) {
						     homer.direction = rand()%(5-3)+3;
						 }
						 else if(homer.olddirection == 3 || homer.olddirection == 4) {
						     homer.direction = rand()%(3-1)+1;
						 }
					 }
			     }
			     if(map.load[(int)(homer.positioni-0.20f)][(int)(homer.positionj)] != '1') {
				     homer.oldexc3x = homer.x;
				     homer.oldexc3y = homer.y;
				     homer.oldexc3z = homer.z;
					 homer.olddirection = homer.direction;
					 homer.iswallleft = 0;
			     }
		         else if(map.load[(int)(homer.positioni-0.20f)][(int)(homer.positionj)] == '1') {
				     homer.x = homer.oldexc3x;
				     homer.y = homer.oldexc3y;
				     homer.z = homer.oldexc3z;
					 homer.iswallleft = 1;
				     if(!homer.iskill) {
						 if(homer.olddirection == 1 || homer.olddirection == 2) {
						     homer.direction = rand()%(5-3)+3;
						 }
						 else if(homer.olddirection == 3 || homer.olddirection == 4) {
						     homer.direction = rand()%(3-1)+1;
						 }
					 }
			     }			 
			     if(map.load[(int)(homer.positioni)][(int)(homer.positionj-0.20f)] != '1') {
				     homer.oldexc4x = homer.x;
				     homer.oldexc4y = homer.y;
				     homer.oldexc4z = homer.z;
					 homer.olddirection = homer.direction;
					 homer.iswalldown = 0;
			     }
		         else if(map.load[(int)(homer.positioni)][(int)(homer.positionj-0.20f)] == '1') {
				     homer.x = homer.oldexc4x;
				     homer.y = homer.oldexc4y;
				     homer.z = homer.oldexc4z;
					 homer.iswalldown = 1;
				     if(!homer.iskill) {
						 if(homer.olddirection == 1 || homer.olddirection == 2) {
						     homer.direction = rand()%(5-3)+3;
						 }
						 else if(homer.olddirection == 3 || homer.olddirection == 4) {
						     homer.direction = rand()%(3-1)+1;
						 }
					 }
			     }
				 homer.iswall = 0;
			 }
			 else {
			     homer.x = homer.oldexc1x;
				 homer.y = homer.oldexc1y;
				 homer.z = homer.oldexc1z;
				 homer.iswall = 1;
				 if(!homer.iskill) {
					 homer.direction = rand()%(5-1)+1;
				 }
			 }
			 
			 if(!homer.iskill) {
	             if(!homer.enabletempopanik) {
					 #ifdef WINDOWS
				     MD2Animation(&monstre, 0.1f, 40.0f, 47.0f);
				     #endif
				     #ifdef PSP
				     MD2Animation(&monstre, 0.6f, 40.0f, 47.0f);
				     #endif
				 }
				 else if(homer.enabletempopanik) {
					 #ifdef WINDOWS
				     MD2Animation(&monstre, 0.1f, 66.0f, 73.0f);
				     #endif
				     #ifdef PSP
				     MD2Animation(&monstre, 0.6f, 66.0f, 73.0f);
				     #endif
				 }    
			 }
			 else if(homer.iskill) {
			     if(monstre.currentframe <= 187.0f) {
				     #ifdef WINDOWS
					 MD2Animation(&monstre, 0.1f, 171.0f, 188.0f);
					 #endif
					 #ifdef PSP
					 MD2Animation(&monstre, 0.6f, 171.0f, 188.0f);
					 #endif
				 }
				 else {
				     #ifdef WINDOWS
					 MD2Animation(&monstre, 0.1f, 188.0f, 188.0f);
					 #endif
					 #ifdef PSP
					 MD2Animation(&monstre, 0.6f, 188.0f, 188.0f);
					 #endif
				 }
			 }
	         MD2Display(&monstre, monstre.currentframe, texture[4]);
	 glPopMatrix();
	 
	 for(i=0; i<=map.linemax; i++) {
	     for(j=0; j<=map.numbermax; j++) {
	         //if(cubeInFrustum(i*6.0f, j*6.0f, 0.0f, 3.0f, &frustum) == 1 || cubeInFrustum(i*6.0f, j*6.0f, 0.0f, 3.0f, &frustum) == 2) {
			     if(map.load[i][j] == '1') {
				     glBindTexture(GL_TEXTURE_2D, texture[map.texture[i][j]]);
					 glBegin(GL_TRIANGLE_STRIP);//pas GL_QUADS car plus rapide pour la carte graphique :)//GL_TRIANGLE_STRIP prend les 2derniers sommets pour coller le 2me triangle au premier pour former un quadrilatre 
					 glTexCoord2f(1.0f, 1.0f); glVertex3f(i*6.0f-3.0f, j*6.0f+3.0f, -3.0f);
					 glTexCoord2f(1.0f, 0.0f); glVertex3f(i*6.0f+3.0f, j*6.0f+3.0f, -3.0f);				     
					 glTexCoord2f(0.0f, 1.0f); glVertex3f(i*6.0f-3.0f, j*6.0f+3.0f, 3.0f);
				     glTexCoord2f(0.0f, 0.0f); glVertex3f(i*6.0f+3.0f, j*6.0f+3.0f, 3.0f);
					 glEnd();
					 glBegin(GL_TRIANGLE_STRIP);
				     glTexCoord2f(0.0f, 1.0f); glVertex3f(i*6.0f-3.0f, j*6.0f+3.0f, -3.0f);
					 glTexCoord2f(1.0f, 1.0f); glVertex3f(i*6.0f-3.0f, j*6.0f-3.0f, -3.0f);
				     glTexCoord2f(0.0f, 0.0f); glVertex3f(i*6.0f-3.0f, j*6.0f+3.0f, 3.0f);
				     glTexCoord2f(1.0f, 0.0f); glVertex3f(i*6.0f-3.0f, j*6.0f-3.0f, 3.0f);
					 glEnd();
					 glBegin(GL_TRIANGLE_STRIP);
				     glTexCoord2f(0.0f, 1.0f); glVertex3f(i*6.0f-3.0f, j*6.0f-3.0f, -3.0f);
				     glTexCoord2f(0.0f, 0.0f); glVertex3f(i*6.0f-3.0f, j*6.0f-3.0f, 3.0f);
					 glTexCoord2f(1.0f, 1.0f); glVertex3f(i*6.0f+3.0f, j*6.0f-3.0f, -3.0f);
				     glTexCoord2f(1.0f, 0.0f); glVertex3f(i*6.0f+3.0f, j*6.0f-3.0f, 3.0f);
					 glEnd();
					 glBegin(GL_TRIANGLE_STRIP);
				     glTexCoord2f(1.0f, 0.0f); glVertex3f(i*6.0f+3.0f, j*6.0f+3.0f, 3.0f);
					 glTexCoord2f(0.0f, 0.0f); glVertex3f(i*6.0f+3.0f, j*6.0f-3.0f, 3.0f);
				     glTexCoord2f(1.0f, 1.0f); glVertex3f(i*6.0f+3.0f, j*6.0f+3.0f, -3.0f);	
					 glTexCoord2f(0.0f, 1.0f); glVertex3f(i*6.0f+3.0f, j*6.0f-3.0f, -3.0f);
					 glEnd();
	             } 
	         /*}*/
		 }
	 }
	 
	 #ifdef WINDOWS
	     map.avancement+=0.005f;
	 #endif
     #ifdef PSP
	     map.avancement+=0.05f;
	 #endif
	 map.avancement = map.avancement>=10.0f?0.0f:map.avancement;
	 
	 glBindTexture(GL_TEXTURE_2D, texture[3]);
	 for(i=0; i<=map.linemax; i++) {
	     for(j=0; j<=map.numbermax; j++) {
			 if(map.load[i][j] != '1') {
		         glBegin(GL_TRIANGLE_STRIP);
				 glTexCoord2f(1.0f+map.avancement, 0.0f+map.avancement); glVertex3f(i*6.0f-3.0f, j*6.0f-3.0f, 3.0f);
				 glTexCoord2f(0.0f+map.avancement, 0.0f+map.avancement); glVertex3f(i*6.0f+3.0f, j*6.0f-3.0f, 3.0f);
		         glTexCoord2f(1.0f+map.avancement, 1.0f+map.avancement); glVertex3f(i*6.0f-3.0f, j*6.0f+3.0f, 3.0f);
		         glTexCoord2f(0.0f+map.avancement, 1.0f+map.avancement); glVertex3f(i*6.0f+3.0f, j*6.0f+3.0f, 3.0f);
                 glEnd();
			 }
	     }
	 }	 
	 
	 glBindTexture(GL_TEXTURE_2D, texture[5]);
	 for(i=0; i<=map.linemax; i++) {
	     for(j=0; j<=map.numbermax; j++) {
			 if(map.load[i][j] != '1') {
				 glBegin(GL_TRIANGLE_STRIP);
				 glTexCoord2f(1.0f, 0.0f); glVertex3f(i*6.0f-3.0f, j*6.0f-3.0f, -3.0f);
				 glTexCoord2f(0.0f, 0.0f); glVertex3f(i*6.0f+3.0f, j*6.0f-3.0f, -3.0f);
		         glTexCoord2f(1.0f, 1.0f); glVertex3f(i*6.0f-3.0f, j*6.0f+3.0f, -3.0f);
		         glTexCoord2f(0.0f, 1.0f); glVertex3f(i*6.0f+3.0f, j*6.0f+3.0f, -3.0f);
                 glEnd();
			 }
	     }
	 }
	 
	 //glDisable(GL_LIGHTING);
	 glDisable(GL_TEXTURE_2D);
	 
	 displayParticule(&exitparticule, MAX_PARTICULE, 0, 100.0f, 1000.0f, 100.0f, 0, 0);	 
	 
	 glEnable2D(WIDTH_SCREEN, HEIGHT_SCREEN, 0.0f, 1.0f);	 
	 
	 #ifdef PSP
		 if(game.normal) {
			 setTir(&freefly, &arme, &map, &homer, &armeparticule, &pad, homer.x, homer.y, homer.z, 2.0f, 4.0f, 200.0f, 2.0f, texture[0], WIDTH_SCREEN/1.5f, HEIGHT_SCREEN/1.6f, sfxa, sfxb, sfxc, sfxd, sfxe, sfxf, channelsfx, weapon, channelweapon);
	     }
	 #endif
	 
	 if(game.normal) {
	     glColor3ub(255, 0, 0);
	     glLineWidth(2.0f);
	     glBegin(GL_LINES);
	     glVertex2f((WIDTH_SCREEN/2.0f)-2.5f, (HEIGHT_SCREEN/2.0f)-10.0f);
	     glVertex2f((WIDTH_SCREEN/2.0f)-2.5f, (HEIGHT_SCREEN/2.0f)-20.0f);
	     
	     glVertex2f((WIDTH_SCREEN/2.0f)-7.5f, (HEIGHT_SCREEN/2.0f)-5.0f);
	     glVertex2f((WIDTH_SCREEN/2.0f)-17.5f, (HEIGHT_SCREEN/2.0f)-5.0f);
	     
	     glVertex2f((WIDTH_SCREEN/2.0f)+3.5f, (HEIGHT_SCREEN/2.0f)-5.0f);
	     glVertex2f((WIDTH_SCREEN/2.0f)+13.5f, (HEIGHT_SCREEN/2.0f)-5.0f);
	     
	     glVertex2f((WIDTH_SCREEN/2.0f)-2.5f, (HEIGHT_SCREEN/2.0f));
	     glVertex2f((WIDTH_SCREEN/2.0f)-2.5f, (HEIGHT_SCREEN/2.0f)+10.0f);	 
         glEnd();
	 }
	 
	 static int minmipmapx;
	 minmipmapx = (freefly.camera.posx-35.0f)/6.0f;
	 static int minmipmapy;
	 minmipmapy = (freefly.camera.posy-35.0f)/6.0f;
	 if(minmipmapx < 0) minmipmapx = 0;
	 if(minmipmapy < 0) minmipmapy = 0;
	 
	 for(i=minmipmapx; i<map.linemax && i<(freefly.camera.posx+35.0f)/6.0f; i++) {
	     for(j=minmipmapy; j<map.numbermax && j<(freefly.camera.posy+35.0f)/6.0f; j++) {
			 if(map.load[i][j] == '1') {
			     glBegin(GL_TRIANGLE_STRIP);
				 glColor3ub(255, 255, 255);
			     glVertex2f(10.0f+j*4.0f+4.0f, 180.0f+i*4.0f);
				 glVertex2f(10.0f+j*4.0f, 180.0f+i*4.0f);
			     glVertex2f(10.0f+j*4.0f+4.0f, 180.0f+i*4.0f+4.0f);
			     glVertex2f(10.0f+j*4.0f, 180.0f+i*4.0f+4.0f);
			     glEnd();
			 }
			 else if(map.load[i][j] == 'S') {
			     glBegin(GL_TRIANGLE_STRIP);
				 glColor3ub(0, 0, 255);
			     glVertex2f(10.0f+j*4.0f+4.0f, 180.0f+i*4.0f);
				 glVertex2f(10.0f+j*4.0f, 180.0f+i*4.0f);
			     glVertex2f(10.0f+j*4.0f+4.0f, 180.0f+i*4.0f+4.0f);
			     glVertex2f(10.0f+j*4.0f, 180.0f+i*4.0f+4.0f);
				 glEnd();
			 }
		 }
	 }
	 glBegin(GL_TRIANGLE_STRIP);
		 glColor3ub(255, 0, 0);
			 glVertex2f(10.0f+((freefly.camera.posy)/1.5f)+6.0f, 180.0f+((freefly.camera.posx)/1.5f));
			 glVertex2f(10.0f+((freefly.camera.posy)/1.5f), 180.0f+((freefly.camera.posx)/1.5f));//on divise par 1.5f car 6.0f/4.0f = 1.5f
			 glVertex2f(10.0f+((freefly.camera.posy)/1.5f)+6.0f, 180.0f+((freefly.camera.posx)/1.5f)+6.0f);
			 glVertex2f(10.0f+((freefly.camera.posy)/1.5f), 180.0f+((freefly.camera.posx)/1.5f)+6.0f);
	 glEnd();
	 
	 if(((homer.y-1.5f)/6.0f) > minmipmapy && ((homer.x-1.5f)/6.0f) > minmipmapx && ((homer.y+1.5f)/6.0f) < ((freefly.camera.posy+35.0f)/6.0f) && ((homer.x+1.5f)/6.0f) < ((freefly.camera.posx+35.0f)/6.0f)) {//if homer is in the zone then we can see him in the mini map
	     glBegin(GL_TRIANGLE_STRIP);
		     glColor3ub(255, 255, 0);
			 glVertex2f(10.0f+((homer.y)/1.5f)+6.0f, 180.0f+((homer.x)/1.5f));
			 glVertex2f(10.0f+((homer.y)/1.5f), 180.0f+((homer.x)/1.5f));
			 glVertex2f(10.0f+((homer.y)/1.5f)+6.0f, 180.0f+((homer.x)/1.5f)+6.0f);
			 glVertex2f(10.0f+((homer.y)/1.5f), 180.0f+((homer.x)/1.5f)+6.0f);	 
	     glEnd();
	 }
	 
	 glColor3f(1.0f, 1.0f, 1.0f);
	 glEnable(GL_TEXTURE_2D);
	 glEnable(GL_ALPHA_TEST);
	 
	 glBindTexture(GL_TEXTURE_2D, texture[7]);
	 glBegin(GL_TRIANGLE_STRIP);
	 glTexCoord2f(0.0f, 0.0f); glVertex2f(306.0f, 5.0f);
	 glTexCoord2f(1.0f, 0.0f); glVertex2f(306.0f+homer.life*2.04f, 5.0f);
	 glTexCoord2f(0.0f, 1.0f); glVertex2f(306.0f, 14.4f);
	 glTexCoord2f(1.0f, 1.0f); glVertex2f(306.0f+homer.life*2.04f, 14.4f);
	 glEnd();
	 
	 if(!homer.iskill) {
	     homer.countkillfirst = SDL_GetTicks();
	 }
	 else if(homer.iskill) {
	     homer.countkillend = SDL_GetTicks()-homer.countkillfirst;
		 if(homer.countkillend < 3000) {
		     glAlphaFunc(GL_GREATER, 0.2f);
	         glBindTexture(GL_TEXTURE_2D, texture[8]);
		     glBegin(GL_TRIANGLE_STRIP);
		     glTexCoord2f(0.0f, 0.0f); glVertex2f(5.0f, 5.0f);
		     glTexCoord2f(1.0f, 0.0f); glVertex2f(200.0f, 5.0f);
		     glTexCoord2f(0.0f, 1.0f); glVertex2f(5.0f, 180.0f);
		     glTexCoord2f(1.0f, 1.0f); glVertex2f(200.0f, 180.0f);
		     glEnd();
		 }
	 }	 
	 
	 if(game.normal) {
	     glAlphaFunc(GL_GREATER, 0.4f);
	     glBindTexture(GL_TEXTURE_2D, texture[19]);
	     glBegin(GL_TRIANGLE_STRIP);
	     glTexCoord2f(0.0f, 0.0f); glVertex2f(320.0f, 60.0f);
	     glTexCoord2f(0.0f, 1.0f); glVertex2f(320.0f, HEIGHT_SCREEN);
	     glTexCoord2f(1.0f, 0.0f); glVertex2f(WIDTH_SCREEN, 60.0f);
	     glTexCoord2f(1.0f, 1.0f); glVertex2f(WIDTH_SCREEN, HEIGHT_SCREEN);
	     glEnd();
	 }
	     
	 glAlphaFunc(GL_EQUAL, 1.0f);
	 glBindTexture(GL_TEXTURE_2D, texture[6]);
	 glBegin(GL_TRIANGLE_STRIP);
	 glTexCoord2f(0.0f, 0.0f); glVertex2f(300.0f, 2.0f);
	 glTexCoord2f(1.0f, 0.0f); glVertex2f(500.0f, 2.0f);
	 glTexCoord2f(0.0f, 1.0f); glVertex2f(300.0f, 21.5f);
	 glTexCoord2f(1.0f, 1.0f); glVertex2f(500.0f, 21.5f);
	 glEnd();
	 
	 #ifdef WINDOWS
		 if(game.normal) {
			 setTir(&freefly, &arme, &map, &homer, &armeparticule, &event, homer.x, homer.y, homer.z, 2.0f, 10.0f, 1000.0f, 2.0f, texture[0], WIDTH_SCREEN/1.5f, HEIGHT_SCREEN/1.6f, sfxa, sfxb, sfxc, sfxd, sfxe, sfxf, channelsfx, weapon, channelweapon);
		 }
		 glEnable(GL_TEXTURE_2D);
		 //setTir(&freefly, &arme, &map, &homer, &event, homer.x, homer.y, homer.z, 2.0f, 6, homer_en_donnut, homer_hehe, homer_woho, homer_en_evil, homer_en_millous, homer_en_hell, 4, weapon, 3);
	 #endif	 
	 
	 /*if(arme.explosiondraw == 1) {
		 //explosion
		 glColor3f(1.0f, 1.0f, 1.0f);//on nettoie les couleurs pour affiche la texture avec sa bonne couleur
		 glEnable(GL_TEXTURE_2D);
		 glEnable(GL_ALPHA_TEST);
		 glAlphaFunc(GL_EQUAL, 1.0f);
		 glBindTexture(GL_TEXTURE_2D, texture[arme.explosionindex]);
		 glBegin(GL_QUADS);
		 glTexCoord2f(0.0f, 0.0f); glVertex2f((480.0f/2.0f)-30.0f, (272.0f/2.0f)+30.0f);
		 glTexCoord2f(1.0f, 0.0f); glVertex2f((480.0f/2.0f)+30.0f, (272.0f/2.0f)+30.0f);
		 glTexCoord2f(1.0f, 1.0f); glVertex2f((480.0f/2.0f)+30.0f, (272.0f/2.0f)-30.0f);
		 glTexCoord2f(0.0f, 1.0f); glVertex2f((480.0f/2.0f)-30.0f, (272.0f/2.0f)-30.0f);
		 glEnd();
	 }
	 
	 if(arme.posx == freefly.camera.posx && arme.posy == freefly.camera.posy && arme.posz == freefly.camera.posz) {
	     sprintf(arme.wecan, "We can fire :O");
	 }
	 else {
	     sprintf(arme.wecan, "Wait before firing!");
	 }*/
	 
	 writeSDLImageFont(texture[1], "Homer's life:", 11.0f, 175.0f, 6.0f, 1, 0.4f);
	 glDisable2D();
}

int main(int argc, char **argv) {
	int i;
	int j;
	
	#ifdef PSP
	 SceUID ebootload = pspSdkLoadStartModule("./system/loadeboot.prx", PSP_MEMORY_PARTITION_KERNEL);
		 
	 if(ebootload < 0) {
		 printf("Attention: erreur 0x08X chargement", ebootload);
		 exit(0);
	 }
		 
	 FILE*pathfile;
	 pathfile = fopen("./system/path.dat", "r");
	 char path[64];
	 char pathsaved[64];			 
		 
	 pspAudioInit();
	 MP3_Init(1);
	 MP3_Load("./data/sfx/menu.mp3");
    #endif	
	
	SDL_Init(SDL_INIT_VIDEO | SDL_INIT_AUDIO);
	TTF_Init();
	
	SDL_Surface*ecran = NULL;
	
	ecran = SDL_SetVideoMode(480, 272, 32, SDL_OPENGL | SDL_FULLSCREEN);
	#ifdef WINDOWS
	SDL_WM_SetCaption("labKillHomer3D par pspflashsystem", NULL);
	#endif
	
	srand((unsigned int)time(NULL));
    
	initGL(WIDTH_SCREEN, HEIGHT_SCREEN);	
	
	 //glDisable(GL_LIGHTING);
	 texture[1] = loadSDLTexture("./data/font.png", 1);
	 glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	 glEnable2D(WIDTH_SCREEN, HEIGHT_SCREEN, -1.0f, 1.0f);
	 writeSDLImageFont(texture[1], "Loading. Please wait :D", 12.0f, 0.0f, 0.0f, 1, 0.4f);
	 glDisable2D();
	 glFlush();
	 SDL_GL_SwapBuffers();
	 //glEnable(GL_LIGHTING);
	
	Mix_OpenAudio(22050, MIX_DEFAULT_FORMAT, MIX_DEFAULT_CHANNELS, 1024);
	#ifdef PSP
	Mix_AllocateChannels(7);
	#endif
	#ifdef WINDOWS
	Mix_AllocateChannels(8);
	Mix_Chunk*menu;
	Mix_Volume(7, MIX_MAX_VOLUME);
	menu = Mix_LoadWAV("./data/sfx/menu.ogg");
	#endif
	Mix_Chunk*ambiance;
	Mix_Chunk*walk;
	Mix_Chunk*weapon;
	Mix_Chunk*homer_en_donnut;
	Mix_Chunk*homer_en_evil;
	Mix_Chunk*homer_en_millous;
	Mix_Chunk*homer_en_hell;
	Mix_Chunk*homer_fr_donnut;
	Mix_Chunk*homer_fr_evil;
	Mix_Chunk*homer_fr_millous;
	Mix_Chunk*homer_fr_hell;	
	Mix_Chunk*homer_woho;
	Mix_Chunk*homer_hehe;
	Mix_Chunk*soundkey;
	Mix_Chunk*victory;
	Mix_Volume(1, MIX_MAX_VOLUME);
	Mix_Volume(2, MIX_MAX_VOLUME);
	Mix_Volume(3, MIX_MAX_VOLUME);
	Mix_Volume(4, MIX_MAX_VOLUME);
	Mix_Volume(5, MIX_MAX_VOLUME);
	Mix_Volume(6, MIX_MAX_VOLUME);
	ambiance = Mix_LoadWAV("./data/sfx/ambiance.wav");
	walk = Mix_LoadWAV("./data/sfx/walk.wav");
	weapon = Mix_LoadWAV("./data/sfx/weapon.wav");
	homer_hehe = Mix_LoadWAV("./data/sfx/homer/hehe.wav");
	homer_woho = Mix_LoadWAV("./data/sfx/homer/woohoo.wav");	
	homer_en_donnut = Mix_LoadWAV("./data/sfx/homer_en/1.wav");
	homer_en_evil = Mix_LoadWAV("./data/sfx/homer_en/2.wav");
	homer_en_millous = Mix_LoadWAV("./data/sfx/homer_en/3.wav");
	homer_en_hell = Mix_LoadWAV("./data/sfx/homer_en/4.wav");
	homer_fr_donnut = Mix_LoadWAV("./data/sfx/homer_fr/1.wav");
	homer_fr_evil = Mix_LoadWAV("./data/sfx/homer_fr/2.wav");
	homer_fr_millous = Mix_LoadWAV("./data/sfx/homer_fr/3.wav");
	homer_fr_hell = Mix_LoadWAV("./data/sfx/homer_fr/4.wav");
	soundkey = Mix_LoadWAV("./data/sfx/key.wav");
	victory = Mix_LoadWAV("./data/sfx/victory.wav");
	
	loadMD2(&monstre, "./data/homer.md2");
	
	texture[0] = loadSDLTexture("./data/particule.png", 1);
	texture[2] = loadSDLTexture("./data/menu.png", 0);
	texture[3] = loadSDLTexture("./data/plafond.jpg", 1);
	texture[4] = loadSDLTexture("./data/skinhomer.pcx", 0);
	texture[5] = loadSDLTexture("./data/sol.jpg", 0);
	texture[6] = loadSDLTexture("./data/barredevie.png", 0);
	texture[7] = loadSDLTexture("./data/jaugevie.png", 0);
	texture[8] = loadSDLTexture("./data/death.png", 0);
	texture[9] = loadSDLTexture("./data/mursplash.jpg", 0);
	texture[10] = loadSDLTexture("./data/mur.jpg", 1);
	texture[11] = loadSDLTexture("./data/mur1.jpg", 1);
	texture[12] = loadSDLTexture("./data/mur2.jpg", 1);
	texture[13] = loadSDLTexture("./data/mur3.jpg", 1);
	texture[14] = loadSDLTexture("./data/mur4.jpg", 1);
	texture[15] = loadSDLTexture("./data/mur5.jpg", 1);
	texture[16] = loadSDLTexture("./data/cursor.png", 0);
	texture[17] = loadSDLTexture("./data/homersound_en.png", 0);
	texture[18] = loadSDLTexture("./data/homersound_fr.png", 0);
	texture[19] = loadSDLTexture("./data/mitrailleuse.png", 0);
	texture[20] = loadSDLTexture("./data/solsplash.jpg", 0);
	texture[21] = loadSDLTexture("./data/splashscreen.png", 0);
	texture[22] = loadSDLTexture("./data/background.png", 0);
	
	map.positioni = 0;
	map.positionj = 0;
	map.avancement = 0.0f;
	
	homer.sfx = 0;
	homer.sfxcount = 0;
	
	 ListFile(&dirscan, &infoscan, "./data/custommap/");
	 infoscan.cursorcount = 0;
	 infoscan.minpage = 0;
	 infoscan.limitepage = 20.0f;
	 
	 #ifdef WINDOWS
	     initFreeFlyCamera(&freefly, freefly.camera.posx, freefly.camera.posy, freefly.camera.posz, 0.3f, 0.4f, RESTRICT);
	     initTir(&arme, MAX_ARME, &armeparticule, MAX_PARTICULE, WIDTH_SCREEN/1.5f, HEIGHT_SCREEN/1.6f, 10.0f, 1000.0f, 2.0f);
	     initFPS(&fps);	 
	 #endif
	 #ifdef PSP
	     initFreeFlyCamera(&freefly, freefly.camera.posx, freefly.camera.posy, freefly.camera.posz, 1.3f, 8.0f, RESTRICT);
	     sceCtrlSetSamplingCycle(0);
         sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);	 
	     SetupCallbacks();
	     scePowerSetClockFrequency(333, 333, 166);
	     int oldpad = 0;
	     initTir(&arme, MAX_ARME, &armeparticule, MAX_PARTICULE, WIDTH_SCREEN/1.5f, HEIGHT_SCREEN/1.6f, 50.0f, 3500.0f, 2.0f);	 
	 #endif
	 
	 splash.x = 0.0f;
	 splash.y = -14.0f;
	 splash.z = 6.0f;
	 //splash.rotation = 0.0f;
	 splash.rebond = 3.0f;
	 
	 game.state = -1;
	 game.cursor = 50.0f;
	 game.cursorbrowser = 0.0f;
	 game.firstaccesslab = 0;
	 game.firstaccesslab2 = 0;
	 game.normal = 1;
	 game.pad = 0;
      
	while(1) {	
         #ifdef WINDOWS
		 delayUpdateFPS(&fps);
		 #endif
		 
		 //Buttons gestion
		 #ifdef WINDOWS
		 while(SDL_PollEvent(&event)) {//une boucle pour viter de retourner plusieurs fois le mme venement :)
		     if(event.type == SDL_QUIT) exit(0);
			     if(event.type == SDL_KEYDOWN) {
				     if(event.key.keysym.sym == SDLK_l) {
					     if(!game.normal) {
						     game.normal = 1;
						 }
						 else if(game.normal) {
						     game.normal = 0;
						 }
					 }
					 if(event.key.keysym.sym == SDLK_DOWN) {
					     if(game.state == 0) {
						     if(game.cursor < 169.0f) {
							     Mix_PlayChannel(6, soundkey, 0);
								 game.cursor+=17.0f;//169 car 17*8(car 8 lments dans le menu)+50 (dpart) -17(taille du cube de slection)
						     }
						 }
						 else if(game.state == 2) {
						     if((infoscan.cursorcount*12.0f) < (infoscan.total-1.0f)*12.0f) {
							     if(game.cursorbrowser < (infoscan.limitepage)*12.0f) {
								     game.cursorbrowser+=12.0f;
								 }
								 else if(game.cursorbrowser >= (infoscan.limitepage)*12.0f) {
									 infoscan.minpage+=1.0f;
								 }
								 infoscan.cursorcount++;
							 }
						 }
					 }
				     if(event.key.keysym.sym == SDLK_UP) {
					     if(game.state == 0) {
						     if(game.cursor > 50.0f) {
							     Mix_PlayChannel(6, soundkey, 0);
								 game.cursor-=17.0f;
							 }
						 }
						 else if(game.state == 2) {
						     if((infoscan.cursorcount*12.0) > 0.0f) {
							     if(game.cursorbrowser > 0.0f) {
								     game.cursorbrowser-=12.0f;
							     }
							     else if(game.cursorbrowser <= 0.0f) {
							         infoscan.minpage-=1.0f;
							     }
								 infoscan.cursorcount--;
							 }
							 
						 }
					 }
					 if(event.key.keysym.sym == SDLK_SPACE) {
					     if(game.state == 0) {
						     if(game.cursor == 50.0f) {
							     game.normal = 1;
								 game.firstaccesslab2 = 0;
								 if(!game.firstaccesslab) {
									 loadMAP(&map, "./data/map1.map", 15, 10, 25);
	                                 for(i=0; i<map.linemax; i++) {
	                                     for(j=0; j<map.numbermax; j++) {
	                                         if(map.load[i][j] == '+') {//position du monstre signal par un + dans la map
			                                     homer.x = i*6.0f;
		                                         homer.y = j*6.0f;
			                                     homer.z = -1.5f;
					                             homer.direction = 1;
					                             homer.speed = 0.5f;
					                             homer.life = 100;
												 homer.iskill = 0;
											     homer.enabletempopanik = 0;	 
		                                     }
			                                 if(map.load[i][j] == 'P') {
			                                     freefly.camera.oldposx = i*6.0f;
				                                 freefly.camera.oldposy = j*6.0f;
			                                     freefly.camera.oldexc1posx = i*6.0f;//on enregistre les anciennes positions en la position de dpart pour viter tout bug de collision au dpart avec la map
				                                 freefly.camera.oldexc1posy = j*6.0f;
			                                     freefly.camera.oldexc2posx = i*6.0f;
				                                 freefly.camera.oldexc2posy = j*6.0f;
			                                     freefly.camera.oldexc3posx = i*6.0f;
				                                 freefly.camera.oldexc3posy = j*6.0f;
			                                     freefly.camera.oldexc4posx = i*6.0f;
				                                 freefly.camera.oldexc4posy = j*6.0f;
				                                 freefly.camera.posx = i*6.0f;
				                                 freefly.camera.posy = j*6.0f;
				                                 freefly.camera.posz = 0.0f;
											     freefly.camera.lateralx = i*6.0f;
											     freefly.camera.lateraly = j*6.0f;
											     freefly.camera.lateralz = 0.0f;
			                                 }
										     if(map.load[i][j] == 'S') {
										         initParticule(&exitparticule, MAX_PARTICULE, i*6.0f, j*6.0f, 0.0f, 0, 100.0f, 1000.0f, 100.0f);
										     }
										 }
	                                 }	
									 game.firstaccesslab = 1;
								 }
								 Mix_HaltChannel(5);//ion arrete le son de la victoire :p
								 Mix_HaltChannel(6);
								 Mix_HaltChannel(7);
						         Mix_PlayChannel(1, ambiance, -1);
					             game.state = 1;
					         }
						     else if(game.cursor == 67.0f) {
								 game.normal = 1;
								 game.firstaccesslab = 0;
								 if(!game.firstaccesslab2) {
									 loadMAP(&map, "./data/map2.map", 15, 10, 25);
	                                 for(i=0; i<map.linemax; i++) {
	                                     for(j=0; j<map.numbermax; j++) {
	                                         if(map.load[i][j] == '+') {//position du monstre signal par un + dans la map
			                                     homer.x = i*6.0f;
		                                         homer.y = j*6.0f;
			                                     homer.z = -1.5f;
					                             homer.direction = 1;
					                             homer.speed = 0.5f;
					                             homer.life = 100;
												 homer.iskill = 0;
											     homer.enabletempopanik = 0;
		                                     }
			                                 if(map.load[i][j] == 'P') {
			                                     freefly.camera.oldposx = i*6.0f;
				                                 freefly.camera.oldposy = j*6.0f;
			                                     freefly.camera.oldexc1posx = i*6.0f;//on enregistre les anciennes positions en la position de dpart pour viter tout bug de collision au dpart avec la map
				                                 freefly.camera.oldexc1posy = j*6.0f;
			                                     freefly.camera.oldexc2posx = i*6.0f;
				                                 freefly.camera.oldexc2posy = j*6.0f;
			                                     freefly.camera.oldexc3posx = i*6.0f;
				                                 freefly.camera.oldexc3posy = j*6.0f;
			                                     freefly.camera.oldexc4posx = i*6.0f;
				                                 freefly.camera.oldexc4posy = j*6.0f;
				                                 freefly.camera.posx = i*6.0f;
				                                 freefly.camera.posy = j*6.0f;
				                                 freefly.camera.posz = 0.0f;
											     freefly.camera.lateralx = i*6.0f;
											     freefly.camera.lateraly = j*6.0f;
											     freefly.camera.lateralz = 0.0f;
			                                 }
										     if(map.load[i][j] == 'S') {
										         initParticule(&exitparticule, MAX_PARTICULE, i*6.0f, j*6.0f, 0.0f, 0, 100.0f, 1000.0f, 100.0f);
										     }
										 }
	                                 }	
									 game.firstaccesslab2 = 1;
								 }
								 Mix_HaltChannel(5);
								 Mix_HaltChannel(6);
								 Mix_HaltChannel(7);
						         Mix_PlayChannel(1, ambiance, -1);
					             game.state = 1;
					         }		 
						     else if(game.cursor == 84.0f) {
						         Mix_HaltChannel(5);//on arrete le son de la victoire :p
								 Mix_HaltChannel(6);
								 Mix_HaltChannel(7);
								 game.state = 2;
						     }
							 else if(game.cursor == 118.0f) {
							     Mix_HaltChannel(5);
								 Mix_HaltChannel(6);
								 Mix_HaltChannel(7);
								 game.state = 3;
							 }
						     else if(game.cursor == 135.0f) {
						         Mix_HaltChannel(5);
								 Mix_HaltChannel(6);
								 Mix_HaltChannel(7);
								 game.state = 4;
						     }
							 else if(game.cursor == 152.0f) {
							     Mix_HaltChannel(5);
								 Mix_HaltChannel(6);
								 Mix_HaltChannel(7);
								 game.state = 5;
							 }
						     else if(game.cursor == 169.0f) {
						         exit(0);
						     }							 
					     }
						 else if(game.state == 2) {
							 if(IsMap(&dirscan, infoscan.cursorcount)) {
								 game.normal = 1;
								 game.firstaccesslab = 0;
								 game.firstaccesslab2 = 0;
								 sprintf(infoscan.src, "./data/custommap/%s", dirscan[infoscan.cursorcount].name);
				                 loadMAP(&map, infoscan.src, 15, 10, 25);
	                             for(i=0; i<map.linemax; i++) {
	                                 for(j=0; j<map.numbermax; j++) {
	                                     if(map.load[i][j] == '+') {//position du monstre signal par un + dans la map
			                                 homer.x = i*6.0f;
		                                     homer.y = j*6.0f;
			                                 homer.z = -1.5f;
					                         homer.direction = 1;
					                         homer.speed = 0.5f;
					                         homer.life = 100;
											 homer.iskill = 0;
											 homer.enabletempopanik = 0;
		                                 }
			                             if(map.load[i][j] == 'P') {
			                                 freefly.camera.oldposx = i*6.0f;
				                             freefly.camera.oldposy = j*6.0f;
			                                 freefly.camera.oldexc1posx = i*6.0f;//on enregistre les anciennes positions en la position de dpart pour viter tout bug de collision au dpart avec la map
				                             freefly.camera.oldexc1posy = j*6.0f;
			                                 freefly.camera.oldexc2posx = i*6.0f;
				                             freefly.camera.oldexc2posy = j*6.0f;
			                                 freefly.camera.oldexc3posx = i*6.0f;
				                             freefly.camera.oldexc3posy = j*6.0f;
			                                 freefly.camera.oldexc4posx = i*6.0f;
				                             freefly.camera.oldexc4posy = j*6.0f;
				                             freefly.camera.posx = i*6.0f;
				                             freefly.camera.posy = j*6.0f;
				                             freefly.camera.posz = 0.0f;
											 freefly.camera.lateralx = i*6.0f;
											 freefly.camera.lateraly = j*6.0f;
											 freefly.camera.lateralz = 0.0f;
			                             }
										 if(map.load[i][j] == 'S') {
										     initParticule(&exitparticule, MAX_PARTICULE, i*6.0f, j*6.0f, 0.0f, 0, 100.0f, 1000.0f, 100.0f);
										 }										 
		                             }
	                             }						 
						         Mix_PlayChannel(1, ambiance, -1);
					             game.state = 1;							 
							 }							 
						 }
					 }
					 if(event.key.keysym.sym == SDLK_RIGHT) {
					     if(game.state == 0) {
						     if(homer.sfxcount < 1) homer.sfxcount++;
							 else if(homer.sfxcount >= 1) homer.sfxcount = 0;	
							 Mix_PlayChannel(6, soundkey, 0);
						 }
					 }
					 if(event.key.keysym.sym == SDLK_LEFT) {
					     if(game.state == 0) {
						     if(homer.sfxcount > 0) homer.sfxcount --;//changement du dossier son
							 else if(homer.sfxcount <= 0) homer.sfxcount = 1;
							 Mix_PlayChannel(6, soundkey, 0);
						 }
					 }
					 if(event.key.keysym.sym == SDLK_BACKSPACE) {
					     if(game.state != 0) {
							 game.state = 0;
			                 Mix_PlayChannel(7, menu, -1);
						 }
					 }
					 if(event.key.keysym.sym == SDLK_UP || event.key.keysym.sym == SDLK_DOWN || event.key.keysym.sym == SDLK_RIGHT || event.key.keysym.sym == SDLK_LEFT) {
				         if(game.state == 1) {
						     if(game.normal) {
							     Mix_PlayChannel(2, walk, -1);	
							 }
						 }
				     }
				     if(game.state == 1) {
					     keyboardGestionFreeFlyCamera(&freefly, &event);
					 }
				     if(event.key.keysym.sym == SDLK_ESCAPE) {
					     exit(0);		
					 }	 
				 }
			     if(event.type == SDL_KEYUP) {
			         if(event.key.keysym.sym == SDLK_UP || event.key.keysym.sym == SDLK_DOWN || event.key.keysym.sym == SDLK_RIGHT || event.key.keysym.sym == SDLK_LEFT) {
				         if(game.state == 1) {
						     Mix_HaltChannel(2);
						 }
				     }
					 if(game.state == 1) {
					     keyboardGestionFreeFlyCamera(&freefly, &event);
					 }
			     }
			     if(event.type == SDL_MOUSEMOTION) {
			         if(game.state == 1) {
					     mouseMotionGestionFreeFlyCamera(&freefly, &event);
					 }
			     }					 
		 }
		 #endif
		 
		 #ifdef PSP
	     sceCtrlPeekBufferPositive(&pad, 1);
		 
		 if(oldpad != pad.Buttons) { 	
				 if(pad.Buttons & PSP_CTRL_RIGHT) {
					     if(game.state == 0) {						     
							 if(homer.sfxcount < 1) homer.sfxcount++;
							 else if(homer.sfxcount >= 1) homer.sfxcount = 0;
							 Mix_PlayChannel(6, soundkey, 0);
						 }
						 /*else if(game.state == 1) {
						     if(game.pad < 1) game.pad++;
							 else if(game.pad >= 1) game.pad = 0;
						 }*/
				 }
				 else if(pad.Buttons & PSP_CTRL_LEFT) {
					     if(game.state == 0) {						     
							 if(homer.sfxcount > 0) homer.sfxcount --;//changement du dossier son
							 else if(homer.sfxcount <= 0) homer.sfxcount = 1;
							 Mix_PlayChannel(6, soundkey, 0);
						 }
						 /*else if(game.state == 1) {
						     if(game.pad > 0) game.pad--;
							 else if(game.pad <= 0) game.pad = 1;
						 }*/
				 }				 
				 else if(pad.Buttons & PSP_CTRL_UP) {
					     if(game.state == 0) {
						     if(game.cursor > 50.0f) {
							     Mix_PlayChannel(6, soundkey, 0);
								 game.cursor-=17.0f;
							 }
						 }
						 else if(game.state == 2) {
						     if((infoscan.cursorcount*12.0) > 0.0f) {
							     if(game.cursorbrowser > 0.0f) {
								     game.cursorbrowser-=12.0f;
							     }
							     else if(game.cursorbrowser <= 0.0f) {
							         infoscan.minpage-=1.0f;
							     }
								 infoscan.cursorcount--;
							 }
							 
						 }
				 }
				 else if(pad.Buttons & PSP_CTRL_DOWN) {
					     if(game.state == 0) {
						     if(game.cursor < 169.0f) {
							     Mix_PlayChannel(6, soundkey, 0);
							     game.cursor+=17.0f;//169 car 17*8(car 8 lments dans le menu)+50 (dpart) -17(taille du cube de slection)
						     }
						 }
						 else if(game.state == 2) {
						     if((infoscan.cursorcount*12.0f) < (infoscan.total-1.0f)*12.0f) {
							     if(game.cursorbrowser < (infoscan.limitepage)*12.0f) {
								     game.cursorbrowser+=12.0f;
								 }
								 else if(game.cursorbrowser >= (infoscan.limitepage)*12.0f) {
									 infoscan.minpage+=1.0f;
								 }
								 infoscan.cursorcount++;
							 }
						 }
				 }
				 else if(pad.Buttons & PSP_CTRL_SELECT) {
				     if(!game.normal) {
					     game.normal = 1;
					 }
					 else if(game.normal) {
					     game.normal = 0;
					 }
				 }
				 else if(pad.Buttons & PSP_CTRL_CROSS) {
					     if(game.state == 0) {
						     if(game.cursor == 50.0f) {
								 game.normal = 1;
								 game.firstaccesslab2 = 0;
								 if(!game.firstaccesslab) {
									 loadMAP(&map, "./data/map1.map", 15, 10, 25);
	                                 for(i=0; i<map.linemax; i++) {
	                                     for(j=0; j<map.numbermax; j++) {
	                                         if(map.load[i][j] == '+') {//position du monstre signal par un + dans la map
			                                     homer.x = i*6.0f;
		                                         homer.y = j*6.0f;
			                                     homer.z = -1.5f;
					                             homer.direction = 1;
					                             homer.speed = 1.0f;
					                             homer.life = 100;
												 homer.iskill = 0;
											     homer.enabletempopanik = 0;
		                                     }
			                                 if(map.load[i][j] == 'P') {
			                                     freefly.camera.oldposx = i*6.0f;
				                                 freefly.camera.oldposy = j*6.0f;
			                                     freefly.camera.oldexc1posx = i*6.0f;//on enregistre les anciennes positions en la position de dpart pour viter tout bug de collision au dpart avec la map
				                                 freefly.camera.oldexc1posy = j*6.0f;
			                                     freefly.camera.oldexc2posx = i*6.0f;
				                                 freefly.camera.oldexc2posy = j*6.0f;
			                                     freefly.camera.oldexc3posx = i*6.0f;
				                                 freefly.camera.oldexc3posy = j*6.0f;
			                                     freefly.camera.oldexc4posx = i*6.0f;
				                                 freefly.camera.oldexc4posy = j*6.0f;
				                                 freefly.camera.posx = i*6.0f;
				                                 freefly.camera.posy = j*6.0f;
				                                 freefly.camera.posz = 0.0f;
											     freefly.camera.lateralx = i*6.0f;
											     freefly.camera.lateraly = j*6.0f;
											     freefly.camera.lateralz = 0.0f;
			                                 }
										     if(map.load[i][j] == 'S') {
										         initParticule(&exitparticule, MAX_PARTICULE, i*6.0f, j*6.0f, 0.0f, 0, 300.0f, 1000.0f, 2.0f);
										     }
										 }
	                                 }	
									 game.firstaccesslab = 1;
								 }
								 Mix_HaltChannel(5);//on arrete le son de la victoire :p
								 Mix_HaltChannel(6);
						         Mix_PlayChannel(1, ambiance, -1);
								 MP3_Stop();
					             game.state = 1;
					         }
						     else if(game.cursor == 67.0f) {
								 game.normal = 1;
								 game.firstaccesslab = 0;
								 if(!game.firstaccesslab2) {
									 loadMAP(&map, "./data/map2.map", 15, 10, 25);
	                                 for(i=0; i<map.linemax; i++) {
	                                     for(j=0; j<map.numbermax; j++) {
	                                         if(map.load[i][j] == '+') {//position du monstre signal par un + dans la map
			                                     homer.x = i*6.0f;
		                                         homer.y = j*6.0f;
			                                     homer.z = -1.5f;
					                             homer.direction = 1;
					                             homer.speed = 1.0f;
					                             homer.life = 100;
												 homer.iskill = 0;
											     homer.enabletempopanik = 0;
		                                     }
			                                 if(map.load[i][j] == 'P') {
			                                     freefly.camera.oldposx = i*6.0f;
				                                 freefly.camera.oldposy = j*6.0f;
			                                     freefly.camera.oldexc1posx = i*6.0f;//on enregistre les anciennes positions en la position de dpart pour viter tout bug de collision au dpart avec la map
				                                 freefly.camera.oldexc1posy = j*6.0f;
			                                     freefly.camera.oldexc2posx = i*6.0f;
				                                 freefly.camera.oldexc2posy = j*6.0f;
			                                     freefly.camera.oldexc3posx = i*6.0f;
				                                 freefly.camera.oldexc3posy = j*6.0f;
			                                     freefly.camera.oldexc4posx = i*6.0f;
				                                 freefly.camera.oldexc4posy = j*6.0f;
				                                 freefly.camera.posx = i*6.0f;
				                                 freefly.camera.posy = j*6.0f;
				                                 freefly.camera.posz = 0.0f;
											     freefly.camera.lateralx = i*6.0f;
											     freefly.camera.lateraly = j*6.0f;
											     freefly.camera.lateralz = 0.0f;
			                                 }
										     if(map.load[i][j] == 'S') {
										         initParticule(&exitparticule, MAX_PARTICULE, i*6.0f, j*6.0f, 0.0f, 0, 300.0f, 1000.0f, 2.0f);
										     }
										 }
	                                 }	
									 game.firstaccesslab2 = 1;
								 }
								 Mix_HaltChannel(5);//on arrete le son de la victoire :p
								 Mix_HaltChannel(6);
						         Mix_PlayChannel(1, ambiance, -1);
								 MP3_Stop();
					             game.state = 1;
					         }		 
						     else if(game.cursor == 84.0f) {
						         Mix_HaltChannel(5);
								 Mix_HaltChannel(6);
								 MP3_Stop();
								 game.state = 2;
						     }
							 else if(game.cursor == 101.0f) {//we load the editor :)
							     if(pathfile > 0) {
								     while(fgets(path, sizeof(path), pathfile) > 0) {
									     if(path[0] == 'e') {
										     sscanf(path+2, "%s", &pathsaved);
										 }
									 }
								     fclose(pathfile);
								 }
								 else if(pathfile <= 0) {
								     fclose(pathfile);
									 sprintf(pathsaved, "ms0:/PSP/GAME/labKillHomer3D/system/editor/EBOOT.PBP");
								 }								 
								 if(loadEboot(pathsaved) == 1) {
	                                 MP3_End();
									 SDL_FreeSurface(ecran);
	                                 Mix_FreeChunk(ambiance);
									 Mix_FreeChunk(soundkey);
	                                 Mix_FreeChunk(walk);
	                                 Mix_FreeChunk(weapon);
	                                 Mix_FreeChunk(homer_hehe);
	                                 Mix_FreeChunk(homer_woho);	
	                                 Mix_FreeChunk(homer_en_donnut);
	                                 Mix_FreeChunk(homer_en_evil);
	                                 Mix_FreeChunk(homer_en_millous);
	                                 Mix_FreeChunk(homer_en_hell);
	                                 Mix_FreeChunk(homer_fr_donnut);
	                                 Mix_FreeChunk(homer_fr_evil);
	                                 Mix_FreeChunk(homer_fr_millous);
	                                 Mix_FreeChunk(homer_fr_hell);
                                     Mix_FreeChunk(victory);	
	                                 Mix_CloseAudio();
	                                 SDL_Quit();
	                                 TTF_Quit();
								 }
							 }							 
							 else if(game.cursor == 118.0f) {
							     Mix_HaltChannel(5);
								 Mix_HaltChannel(6);
								 MP3_Stop();
								 game.state = 3;
							 }
						     else if(game.cursor == 135.0f) {
						         Mix_HaltChannel(5);
								 Mix_HaltChannel(6);
								 MP3_Stop();
								 game.state = 4;
						     }
							 else if(game.cursor == 152.0f) {
							     Mix_HaltChannel(5);
								 Mix_HaltChannel(6);
								 MP3_Stop();
								 game.state = 5;
							 }
							 else if(game.cursor == 169.0f) {
							     exit(0);
							 }
					     }
						 else if(game.state == 2) {
							 if(IsMap(&dirscan, infoscan.cursorcount)) {
								 game.normal = 1;
								 game.firstaccesslab = 0;
								 game.firstaccesslab2 = 0;
								 sprintf(infoscan.src, "./data/custommap/%s", dirscan[infoscan.cursorcount].name);
				                 loadMAP(&map, infoscan.src, 15, 10, 25);
	                             for(i=0; i<map.linemax; i++) {
	                                 for(j=0; j<map.numbermax; j++) {
	                                     if(map.load[i][j] == '+') {//position du monstre signal par un + dans la map
			                                 homer.x = i*6.0f;
		                                     homer.y = j*6.0f;
			                                 homer.z = -1.5f;
					                         homer.direction = 1;
					                         homer.speed = 1.0f;
					                         homer.life = 100;
											 homer.iskill = 0;
											 homer.enabletempopanik = 0;
		                                 }
			                             if(map.load[i][j] == 'P') {
			                                 freefly.camera.oldposx = i*6.0f;
				                             freefly.camera.oldposy = j*6.0f;
			                                 freefly.camera.oldexc1posx = i*6.0f;//on enregistre les anciennes positions en la position de dpart pour viter tout bug de collision au dpart avec la map
				                             freefly.camera.oldexc1posy = j*6.0f;
			                                 freefly.camera.oldexc2posx = i*6.0f;
				                             freefly.camera.oldexc2posy = j*6.0f;
			                                 freefly.camera.oldexc3posx = i*6.0f;
				                             freefly.camera.oldexc3posy = j*6.0f;
			                                 freefly.camera.oldexc4posx = i*6.0f;
				                             freefly.camera.oldexc4posy = j*6.0f;
				                             freefly.camera.posx = i*6.0f;
				                             freefly.camera.posy = j*6.0f;
				                             freefly.camera.posz = 0.0f;
											 freefly.camera.lateralx = i*6.0f;
											 freefly.camera.lateraly = j*6.0f;
											 freefly.camera.lateralz = 0.0f;
			                             }
										 if(map.load[i][j] == 'S') {
										     initParticule(&exitparticule, MAX_PARTICULE, i*6.0f, j*6.0f, 0.0f, 0, 300.0f, 1000.0f, 2.0f);
										 }										 
		                             }
	                             }						 
						         Mix_PlayChannel(1, ambiance, -1);
					             game.state = 1;							 
							 }							 
						 }					 
				 }
				 else if(pad.Buttons & PSP_CTRL_START) {//on retourne  notre choix prcdent
					     if(game.state != 0) {
							 game.state = 0;
							 MP3_Play();
						 }
				 }				 
			     if(!game.pad) {
					 if(pad.Buttons & PSP_CTRL_TRIANGLE || pad.Buttons & PSP_CTRL_CROSS || pad.Buttons & PSP_CTRL_SQUARE || pad.Buttons & PSP_CTRL_CIRCLE) {
				         if(game.state == 1) {
					         if(game.normal) {
						         Mix_PlayChannel(2, walk, -1);
						     }
					     }
				     }
				     else {
				         if(game.state == 1) {
					         Mix_HaltChannel(2);
					     }
			         }
				 }
				 /*else if(game.pad) {
					 if(pad.Lx > 230 || pad.Lx < 60 || pad.Ly > 230 || pad.Ly < 60) {
				         if(game.state == 1) {
					         if(game.normal) {
						         Mix_PlayChannel(2, walk, -1);
						     }
					     }
				     }
				     else {
				         if(game.state == 1) {
					         Mix_HaltChannel(2);
					     }
			         }
				 }	*/			     
		 }
		 oldpad = pad.Buttons;
		 #endif
		 
		 if(game.state == 0) {
			 Mix_HaltChannel(1);//on arrete toutes les sonorits dans le menu :p
			 Mix_HaltChannel(2);
			 Mix_HaltChannel(3);
			 Mix_HaltChannel(4);
		     glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
			 //glDisable(GL_LIGHTING);
			 glEnable(GL_TEXTURE_2D);
			 glEnable(GL_ALPHA_TEST);
			 glAlphaFunc(GL_EQUAL, 1.0f);//glAlphaFunc(GL_EQUAL, 1.0f);
			 glEnable2D(WIDTH_SCREEN, HEIGHT_SCREEN, -1.0f, 1.0f);
				 #ifdef WINDOWS
				 if(homer.sfxcount == 0) {
				     glBindTexture(GL_TEXTURE_2D, texture[17]);
				 }
				 else if(homer.sfxcount == 1) {
				     glBindTexture(GL_TEXTURE_2D, texture[18]);
				 }				 
				 glBegin(GL_TRIANGLE_STRIP);
				 glTexCoord2f(1.0f, 0.0f); glVertex2f(350.0f+100.0f, 170.0f);
				 glTexCoord2f(0.0f, 0.0f); glVertex2f(350.0f, 170.0f);
				 glTexCoord2f(1.0f, 1.0f); glVertex2f(350.0f+100.0f, 170.0f+36.0f);
				 glTexCoord2f(0.0f, 1.0f); glVertex2f(350.0f, 170.0f+36.0f);
				 glEnd();				 
				 glBindTexture(GL_TEXTURE_2D, texture[16]);
				 glBegin(GL_TRIANGLE_STRIP);
				 glTexCoord2f(1.0f, 0.0f); glVertex2f(60.0f, game.cursor);
				 glTexCoord2f(0.0f, 0.0f); glVertex2f(40.0f, game.cursor);
				 glTexCoord2f(1.0f, 1.0f); glVertex2f(60.0f, game.cursor+17.0f);
				 glTexCoord2f(0.0f, 1.0f); glVertex2f(40.0f, game.cursor+17.0f);
				 glEnd();
				 glBindTexture(GL_TEXTURE_2D, texture[2]);
			     glBegin(GL_TRIANGLE_STRIP);
				 glTexCoord2f(1.0f, 0.0f); glVertex2f(WIDTH_SCREEN, 0.0f);
				 glTexCoord2f(0.0f, 0.0f); glVertex2f(0.0f, 0.0f);
				 glTexCoord2f(1.0f, 1.0f); glVertex2f(WIDTH_SCREEN, HEIGHT_SCREEN);
				 glTexCoord2f(0.0f, 1.0f); glVertex2f(0.0f, HEIGHT_SCREEN);
				 glEnd();
				 #endif
				 
				 #ifdef PSP//car l'ordre d'affichage est invers pour la psp
				 glBindTexture(GL_TEXTURE_2D, texture[2]);
			     glBegin(GL_TRIANGLE_STRIP);
				 glTexCoord2f(1.0f, 0.0f); glVertex2f(WIDTH_SCREEN, 0.0f);
				 glTexCoord2f(0.0f, 0.0f); glVertex2f(0.0f, 0.0f);
				 glTexCoord2f(1.0f, 1.0f); glVertex2f(WIDTH_SCREEN, HEIGHT_SCREEN);
				 glTexCoord2f(0.0f, 1.0f); glVertex2f(0.0f, HEIGHT_SCREEN);
				 glEnd();
				 glBindTexture(GL_TEXTURE_2D, texture[16]);
				 glBegin(GL_TRIANGLE_STRIP);
				 glTexCoord2f(1.0f, 0.0f); glVertex2f(60.0f, game.cursor);
				 glTexCoord2f(0.0f, 0.0f); glVertex2f(40.0f, game.cursor);
				 glTexCoord2f(1.0f, 1.0f); glVertex2f(60.0f, game.cursor+17.0f);
				 glTexCoord2f(0.0f, 1.0f); glVertex2f(40.0f, game.cursor+17.0f);
				 glEnd();
				 if(homer.sfxcount == 0) {
				     glBindTexture(GL_TEXTURE_2D, texture[17]);
				 }
				 else if(homer.sfxcount == 1) {
				     glBindTexture(GL_TEXTURE_2D, texture[18]);
				 }				 
				 glBegin(GL_TRIANGLE_STRIP);
				 glTexCoord2f(1.0f, 0.0f); glVertex2f(350.0f+100.0f, 170.0f);
				 glTexCoord2f(0.0f, 0.0f); glVertex2f(350.0f, 170.0f);
				 glTexCoord2f(1.0f, 1.0f); glVertex2f(350.0f+100.0f, 170.0f+36.0f);
				 glTexCoord2f(0.0f, 1.0f); glVertex2f(350.0f, 170.0f+36.0f);
				 glEnd();
				 
				 //problme avec les fat psp donc on mets cela pas encore trouv d'autres solutions (tant que cela fonctionne :p)
	             for(i=0; i<map.linemax; i++) {
	                 for(j=0; j<map.numbermax; j++) {
			             if(map.load[i][j] == '1') {
			                 glBegin(GL_TRIANGLE_STRIP);
				             glColor3ub(255, 255, 255);
			                 glVertex2f(10.0f+j*4.0f+4.0f, 180.0f+i*4.0f);
				             glVertex2f(10.0f+j*4.0f, 180.0f+i*4.0f);
			                 glVertex2f(10.0f+j*4.0f+4.0f, 180.0f+i*4.0f+4.0f);
			                 glVertex2f(10.0f+j*4.0f, 180.0f+i*4.0f+4.0f);
			                 glEnd();
			             }
			             else if(map.load[i][j] == 'S') {
			                 glBegin(GL_TRIANGLE_STRIP);
				             glColor3ub(255, 255, 255);
			                 glVertex2f(10.0f+j*4.0f+4.0f, 180.0f+i*4.0f);
				             glVertex2f(10.0f+j*4.0f, 180.0f+i*4.0f);
			                 glVertex2f(10.0f+j*4.0f+4.0f, 180.0f+i*4.0f+4.0f);
			                 glVertex2f(10.0f+j*4.0f, 180.0f+i*4.0f+4.0f);
				             glEnd();
			             }
		             }
	             }
	             glBegin(GL_TRIANGLE_STRIP);
		             glColor3ub(255, 255, 255);
			             glVertex2f(10.0f+((freefly.camera.posy)/1.5f)+6.0f, 180.0f+((freefly.camera.posx)/1.5f));
			             glVertex2f(10.0f+((freefly.camera.posy)/1.5f), 180.0f+((freefly.camera.posx)/1.5f));//on divise par 1.5f car 6.0f/4.0f = 1.5f
			             glVertex2f(10.0f+((freefly.camera.posy)/1.5f)+6.0f, 180.0f+((freefly.camera.posx)/1.5f)+6.0f);
			             glVertex2f(10.0f+((freefly.camera.posy)/1.5f), 180.0f+((freefly.camera.posx)/1.5f)+6.0f);
	             glEnd();
	             glBegin(GL_TRIANGLE_STRIP);
		             glColor3ub(255, 255, 255);
			             glVertex2f(10.0f+((homer.y)/1.5f)+6.0f, 180.0f+((homer.x)/1.5f));
			             glVertex2f(10.0f+((homer.y)/1.5f), 180.0f+((homer.x)/1.5f));
			             glVertex2f(10.0f+((homer.y)/1.5f)+6.0f, 180.0f+((homer.x)/1.5f)+6.0f);
			             glVertex2f(10.0f+((homer.y)/1.5f), 180.0f+((homer.x)/1.5f)+6.0f);	 
	             glEnd();
				 #endif
		     glDisable2D();
		 }
		 else if(game.state == 1) {
			 #ifdef WINDOWS
			 if(game.normal) {
			     straightGestionFreeFlyCamera(&freefly);
			 }
			 checkMur(&map, &freefly, &homer, &game, 0.11f, victory, 5);
			 setHideCursorMouseFreeFlyCamera(1);
			 #endif
			 #ifdef PSP
			 MP3_Stop();
			 if(!game.pad) {//default buttons
				 if(pad.Buttons & PSP_CTRL_LTRIGGER && (pad.Lx > 230 || pad.Lx < 60 || pad.Ly > 230 || pad.Ly < 60)) {//pour accder au mode prcision du tir :)
				     setFreeFlyCameraPrecision(&freefly, 0.5f);
			     }
			     else {
			         setFreeFlyCameraPrecision(&freefly, 8.0f);
			     }
			 }
			 /*else if(game.pad) {
				 if(pad.Buttons & PSP_CTRL_LTRIGGER && (pad.Buttons & PSP_CTRL_CIRCLE || pad.Buttons & PSP_CTRL_SQUARE || pad.Buttons & PSP_CTRL_CROSS || pad.Buttons & PSP_CTRL_TRIANGLE)) {//pour accder au mode prcision du tir :)
				     setFreeFlyCameraPrecision(&freefly, 0.5f);
			     }
			     else {
			         setFreeFlyCameraPrecision(&freefly, 8.0f);
			     }
			 }*/
			 
             if(game.normal) {
			     straightGestionFreeFlyCamera(&freefly, &pad, game.pad);
			 }
	         mouseMotionGestionFreeFlyCamera(&freefly, &pad, game.pad);
			 checkMur(&map, &freefly, &homer, &game, 0.25f, victory, 5);
			 #endif
			 updateFreeFlyCamera(&freefly);	 			 
		     if(homer.sfxcount == 0) Display(homer_en_donnut, homer_hehe, homer_woho, homer_en_evil, homer_en_millous, homer_en_hell, 4, weapon, 3); 
		     else if(homer.sfxcount == 1) Display(homer_fr_donnut, homer_hehe, homer_woho, homer_fr_evil, homer_fr_millous, homer_fr_hell, 4, weapon, 3);
		 }
		 else if(game.state == 2) {
		     glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
			 glEnable(GL_TEXTURE_2D);
			 glEnable2D(WIDTH_SCREEN, HEIGHT_SCREEN, -1.0f, 1.0f);
			 for(i=infoscan.minpage; i<infoscan.total && i<=infoscan.minpage+infoscan.limitepage; i++) {
				 writeSDLImageFont(texture[1], dirscan[i].name, 12.0f, 12.0f, (i-infoscan.minpage)*12.0f, 1, 0.4f);
			 }
			 writeSDLImageFont(texture[1], ">", 12.0f, 0.0f, game.cursorbrowser, 1, 0.4f);
			 #ifdef WINDOWS
			 glBindTexture(GL_TEXTURE_2D, texture[22]);
			 glBegin(GL_TRIANGLE_STRIP);
			 glTexCoord2f(0.0f, 1.0f); glVertex2f(0.0f, 272.0f);
			 glTexCoord2f(1.0f, 1.0f); glVertex2f(480.0f, 272.0f);
			 glTexCoord2f(0.0f, 0.0f); glVertex2f(0.0f, 0.0f);
			 glTexCoord2f(1.0f, 0.0f); glVertex2f(480.0f, 0.0f);
			 glEnd();	
			 #endif
			 glDisable2D();
		 }
		 else if(game.state == 3) {
		     glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
			 glEnable(GL_TEXTURE_2D);
			 glEnable2D(WIDTH_SCREEN, HEIGHT_SCREEN, -1.0f, 1.0f);
			 #ifdef WINDOWS
			 writeSDLImageFont(texture[1], "Commands:\n\nIn menu:\nUp and down to move the cursor\nRight or left to change homer's language's sound\nSPACE to select your choice\n\nIn game:\nDown, up, left and right to move the player\nMouse to move the camera\nMouse Button left to shoot\nl to go to the sky mode\nBackspace to go to the menu (also in\nhomer's show)\n\nIn map's editor:\nr to change the current element \nx to hang the current element\nor select letter in the keyboard\nSpace to go to editor's menu\nUp, down, right and left to move editor's cursor\n\nI forgot: have fun :D", 11.0f, 0.0f, 0.0f, 1, 0.4f);
			 glBindTexture(GL_TEXTURE_2D, texture[22]);
			 glBegin(GL_TRIANGLE_STRIP);
			 glTexCoord2f(0.0f, 1.0f); glVertex2f(0.0f, 272.0f);
			 glTexCoord2f(1.0f, 1.0f); glVertex2f(480.0f, 272.0f);
			 glTexCoord2f(0.0f, 0.0f); glVertex2f(0.0f, 0.0f);
			 glTexCoord2f(1.0f, 0.0f); glVertex2f(480.0f, 0.0f);
			 glEnd();			 
			 #endif
			 #ifdef PSP
			 glBindTexture(GL_TEXTURE_2D, texture[22]);
			 glBegin(GL_TRIANGLE_STRIP);
			 glTexCoord2f(0.0f, 1.0f); glVertex2f(0.0f, 272.0f);
			 glTexCoord2f(1.0f, 1.0f); glVertex2f(480.0f, 272.0f);
			 glTexCoord2f(0.0f, 0.0f); glVertex2f(0.0f, 0.0f);
			 glTexCoord2f(1.0f, 0.0f); glVertex2f(480.0f, 0.0f);
			 glEnd();			 
			 writeSDLImageFont(texture[1], "Commands:\n\nIn menu:\nUp and down to move the cursor\nRight or left to change homer's language's sound\nCross to select your choice\n\nIn game:\nCross, triangle, circle and square to move (for default buttons)\nAnalog pad to move the camera (for default buttons)\nL + Analog pad to move the camera more precisely\n(good think if you want to shoot more precisely)\nR to shoot\nSelect to go to the sky mode\nStart to go to the menu (also in homer's show)\n\nIn map's editor:\nR to change the current element \nCross to hang the current element\nStart to go to editor's menu\nUp, down, right and left or Analog pad\nto move editor's cursor\n\nI forgot: have fun :D", 11.0f, 0.0f, 0.0f, 1, 0.4f);
			 #endif			 
			 glDisable2D();
		 }
		 else if(game.state == 4) {
			 glLoadIdentity();
			 glDisable(GL_ALPHA_TEST);
			 glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
			 glPushMatrix();
			 glTranslatef(0.0f, 0.0f, -7.0f);
			 glRotatef(270.0f, 0.0f, 1.0f, 0.0f);
			 glRotatef(-90.0f, 1.0f, 0.0f, 0.0f);
			 MD2Animation(&monstre, 0.3f, 0.0f, monstre.header.numberframe);
			 MD2Display(&monstre, monstre.currentframe, texture[4]);
			 glPopMatrix();
		 }
		 else if(game.state == 5) {
		     glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
			 glEnable(GL_TEXTURE_2D);
			 glEnable2D(WIDTH_SCREEN, HEIGHT_SCREEN, -1.0f, 1.0f);
			 #ifdef PSP
			 glBindTexture(GL_TEXTURE_2D, texture[22]);
			 glBegin(GL_TRIANGLE_STRIP);
			 glTexCoord2f(0.0f, 1.0f); glVertex2f(0.0f, 272.0f);
			 glTexCoord2f(1.0f, 1.0f); glVertex2f(480.0f, 272.0f);
			 glTexCoord2f(0.0f, 0.0f); glVertex2f(0.0f, 0.0f);
			 glTexCoord2f(1.0f, 0.0f); glVertex2f(480.0f, 0.0f);
			 glEnd();	
			 #endif			 
			 writeSDLImageFont(texture[1], "Special thanks to:\n\nOfficial Beta Tester: PSPnoObmOd\n\nBeta testers: Furiousdante, Toxic, TheCrach,\n              Fdr and PSPall\n\nPersons who support me: Shiro-chan, makioto,\n                        Shaolan, Daminou, Flo\n                        and spimort\n\nAll staff of www.psp-hacks.com who\nmotivates developers with his competition\n\nCode and gfx (except simpson's gfx):\npspflashsystem\n\nHomer's model from: http://www.fileplanet.com\nFitzhardinge for his OpenGL-like library\n\nTo finish, I would especially like\nto thank my parents", 12.0f, 0.0f, 0.0f, 1, 0.4f);
			 #ifdef WINDOWS
			 glBindTexture(GL_TEXTURE_2D, texture[22]);
			 glBegin(GL_TRIANGLE_STRIP);
			 glTexCoord2f(0.0f, 1.0f); glVertex2f(0.0f, 272.0f);
			 glTexCoord2f(1.0f, 1.0f); glVertex2f(480.0f, 272.0f);
			 glTexCoord2f(0.0f, 0.0f); glVertex2f(0.0f, 0.0f);
			 glTexCoord2f(1.0f, 0.0f); glVertex2f(480.0f, 0.0f);
			 glEnd();	
			 #endif
			 glDisable2D();
		 }
		 else if(game.state == -1) {
			 #ifdef WINDOWS
			 splashscreen(&game, &splash, texture[21], texture[1], menu, 7);
             #endif
			 #ifdef PSP
			 splashscreen(&game, &splash, texture[21], texture[1], NULL, NULL);
			 #endif
		 }
	     glFlush();//permet de s'aasurer que toutes les fonctions d'opengl ont t excut
	     SDL_GL_SwapBuffers();//permet de mettre  jour l'affichage c'est l'quivalent de SDL_Flip() mais avec opengl :)
		 #ifdef WINDOWS
		 delayFPS(&fps, 60.0f);
		 #endif
	}
	#ifdef PSP
	fclose(pathfile);
	MP3_End();
	#endif
	#ifdef WINDOWS
	Mix_FreeChunk(menu);
	#endif
	SDL_FreeSurface(ecran);
	Mix_FreeChunk(soundkey);
	Mix_FreeChunk(ambiance);
	Mix_FreeChunk(walk);
	Mix_FreeChunk(weapon);
	Mix_FreeChunk(homer_hehe);
	Mix_FreeChunk(homer_woho);	
	Mix_FreeChunk(homer_en_donnut);
	Mix_FreeChunk(homer_en_evil);
	Mix_FreeChunk(homer_en_millous);
	Mix_FreeChunk(homer_en_hell);
	Mix_FreeChunk(homer_fr_donnut);
	Mix_FreeChunk(homer_fr_evil);
	Mix_FreeChunk(homer_fr_millous);
	Mix_FreeChunk(homer_fr_hell);
    Mix_FreeChunk(victory);	
	Mix_CloseAudio();
	SDL_Quit();
	TTF_Quit();
	
	//on libre la mmoire alloue prcedemment dynamiquement (dans la fonction loadobj dynamiquement) :)
	freeMD2(&monstre);
	freeMAP(&map);
	glDeleteTextures(23, &texture);
	return 0;
}
